<html>
<head>
    <% FwIncludeFile("/web/charset.txt"); %>
    <meta http-equiv="expires" content="0">
    <meta http-equiv="pragma" content="no-cache">
    <link rel="stylesheet" href="/style.css" type="text/css">
    <script src="/js/jquery-3.6.0.min.js" type="text/javascript"></script>
    <script language=javascript>
        <% FwCameraGet("FwModId","PortId","NO_SNAP"); %>
        <% FwVideoModeGet("FwModId"); %>
        <% FwCamCtlGet(); %>
        <% NssDefAppPorts(); %>
        <% NetDefEth0Cfg(); %>
        <% FwGetRtpRtspInfo(); %>


        function GetData() {
            with( document.all ){
	            var ObjStr;
	            var IP = document.location.hostname;
	            var port;

	            if(IP == ETH0_IP) {
	                if(location.protocol == "http:") {
	                    port = WEBSPORT;
	                }
	                else if (location.protocol == "https:") {
	                    port = HTTPSPORT;
	                }
	                else {
	                    port = document.location.port;
	                    if (port == "") {
	                        port = 80;
	                    }
	                }
	            }
	            else {
	                port = document.location.port;
	            }

                if (navigator.userAgent.match(/MSIE/i) || navigator.userAgent.match(/Trident/i)) {
                    if (GetOSType()) {
                        ObjStr = "<OBJECT classid=CLSID:95E2148E-2C85-4FCE-BB06-6952F3FF7830 " +
                                "codebase=<% FwGetActiveXFilePath("VIEWER_OCX2"); %>#Version=<% FwGetActiveXFilePath("VIEWER_VERSION2"); %> " +
                                "width='430' height='300' id=SVMultiChannelMediaCtl></OBJECT>";
                    }
                    else {
                        ObjStr = "<OBJECT classid=CLSID:95E2148E-2C85-4FCE-BB06-6952F3FF7830 " +
                                "codebase=<% FwGetActiveXFilePath("VIEWER_OCX1"); %>#Version=<% FwGetActiveXFilePath("VIEWER_VERSION1"); %> " +
                                "width='430' height='300' id=SVMultiChannelMediaCtl></OBJECT>"
                    }
                    ViewerArea.innerHTML = ObjStr;

                    if (location.protocol == "https:")
                        SVMultiChannelMediaCtl.SetSSLMode(true);
                    channelHandle = SVMultiChannelMediaCtl.CreateChannel(IP, port, "", 0, FWMODID, Number(PORTID) + 1, <% FwGetUser(); %>, <% FwGetPassEx("2"); %>, 0, 5, 0, 0, 0);
                    SVMultiChannelMediaCtl.SetDrawFit(channelHandle, 2);
                    SVMultiChannelMediaCtl.StartStreaming(channelHandle);
                }
                else {
                    ObjStr = "<iframe id='ViewerIFrame' style='width:430; height:300;'' scrolling='no'></iframe>";
                    ViewerArea.innerHTML = ObjStr;
                    gViewUrl = "./view_websock.asp?FwModId=<% FwGetParmValue("FwModId"); %>&PortId=1";
                    $('#ViewerIFrame').attr('src', gViewUrl);

                    setTimeout(function() {
                        var gwidth = $('#ViewerIFrame').width();
                        var gheight = $('#ViewerIFrame').height();
                        $('#ViewerIFrame').contents().find("#id_image").width(gwidth);
                        $('#ViewerIFrame').contents().find("#id_image").height(gheight);
                        $('#ViewerIFrame').contents().find("#id_image").css("object-fit","fill");
                    }, 100);
                }
                ChgTab(CAMCTLPAGE);
            }
        }



        function ChgTab(TARGET) {
            with (document.all) {
                Awb.value = AWB;
                AwbMnl.value = AWBMNL;
                Rgain.value = RGAIN;
                Bgain.value = BGAIN;
                WhiteBalanceMode();
                Saturation.value = SATURATION;
                Adnr.value = ADNR;

                tab0.className = "menu";
                tab1.className = "menu";
                tab2.className = "menu";
                tab3.className = "menu";
                tab4.className = "selectmenu";
                tab5.className = "menu";
                CamCtlPage.value = 4;
                
            }
        }

        function WhiteBalanceMode() {
            with (document.all) {
                if(Awb.value == 0) {
                    AwbPreset.disabled = true;
                    AwbMnl.disabled = true;
                    Rgain.disabled = true;
                    Bgain.disabled = true;
                }
                else if (Awb.value == 1) {
                    AwbPreset.disabled = true;
                    AwbMnl.disabled = true;
                    Rgain.disabled = true;
                    Bgain.disabled = true;
                }
                else if (Awb.value == 2) {
                    AwbPreset.disabled = false;
                    AwbMnl.disabled = true;
                    Rgain.disabled = true;
                    Bgain.disabled = true;
                }
                else if (Awb.value == 3) {
                    AwbPreset.disabled = true;
                    AwbMnl.disabled = false;
                    Rgain.disabled = false;
                    Bgain.disabled = false;
                }
            }
        }

        function WbPreset() {
            with (document.all) {
                location.href = "/cgi-bin/admin/fwcamctlset.cgi?AwbPreset=1&FwCgiVer=0x0001";
            }
        }
        function SetData() {
            with (document.all) {
                if( isNaN(Rgain.value) == true){
                    alert("\'" + Rgain.value + "\' is not a number.");
                    Rgain.focus();
                    return false;
                }
                if(Rgain.value < 0 || Rgain.value > 20) {
                    alert("Value should be 0 ~ 20");
                    Rgain.focus();
                    return false;
                }

                if( isNaN(Bgain.value) == true){
                    alert("\'" + Bgain.value + "\' is not a number.");
                    Bgain.focus();
                    return false;
                }
                if(Bgain.value < 0 || Bgain.value > 20) {
                    alert("Value should be 0 ~ 20");
                    Bgain.focus();
                    return false;
                }

                if( isNaN(Saturation.value) == true){
                    alert("\'" + Saturation.value + "\' is not a number.");
                    Saturation.focus();
                    return false;
                }
                if(Saturation.value < 0 || Saturation.value > 20) {
                    alert("Value should be 0 ~ 20");
                    Saturation.focus();
                    return false;
                }

                toapply.disabled = true;
            }
        }

        function GetOSType() {
            var osType = navigator.userAgent;

            if ((osType.indexOf("NT 5.2") != -1) || (osType.indexOf("NT 5.1") != -1) || (osType.indexOf("NT 5.0") != -1)) { // Not Supported!
                return false;
            }
            else {
                return true;
            }
        }
    </script>
</head>

<body class=body_Normal onload="GetData();" topmargin=20>
<form name='cam' method=Post action="/cgi-bin/admin/fwcamctlset.cgi" onSubmit="return SetData();">
<table align=center>
    <tr>
        <td align=center height=30><font class=text_Title>Camera Settings</font></td>
    </tr>
    <tr>
        <td>
            <table align=center class=tbl_Normal cellspacing=0>
                <tr>
                    <td colspan="2" align="center" class=td_NormalRight>
                        <div id="ViewerArea"></div>
                    </td>
                </tr>
            </table><br>

            <table align=center class=tbl_Normal cellspacing=0>
                <tr>
                    <td align=right height=25>
                        <a href="/admin/camera/camctrl_GSM_0.asp?FwModId=0&PortId=0" id="tab0" class=menu>Lens</a> &nbsp;<b>|</b>&nbsp;
                        <a href="/admin/camera/camctrl_GSM_1.asp?FwModId=0&PortId=0" id="tab1" class=menu>Exposure</a> &nbsp;<b>|</b>&nbsp;
                        <a href="/admin/camera/camctrl_GSM_2.asp?FwModId=0&PortId=0" id="tab2" class=menu>Back Light</a> &nbsp;<b>|</b>&nbsp;
                        <a href="/admin/camera/camctrl_GSM_3.asp?FwModId=0&PortId=0" id="tab3" class=menu>Day & Night</a> &nbsp;<b>|</b>&nbsp;
                        <a href="/admin/camera/camctrl_GSM_4.asp?FwModId=0&PortId=0" id="tab4" class=menu>White Balance</a> &nbsp;<b>|</b>&nbsp;
                        <a href="/admin/camera/camctrl_GSM_5.asp?FwModId=0&PortId=0" id="tab5" class=menu>Image</a> &nbsp;
                    </td>
                </tr>
                <tr>
                    <td>
                        <table id="id_WhiteBalance" align=center class=tbl_Normal cellspacing=0>
                            <tr>
                                <td width='200' class=td_NormalLeft>&nbsp;White Balance Mode</td>
                                <td width='350' class=td_NormalRight>&nbsp; <select name=Awb onchange="WhiteBalanceMode();">
                                <option value=0>Auto
                                <option value=2>Preset
                                <option value=3>Manual </select> </td>
                            </tr>
                            <tr>
                                <td class=td_NormalLeft>&nbsp;Preset</td>
                                <td class=td_NormalRight>
                                &nbsp; <input type=button class=obj_Button name=AwbPreset style='width:60px;' value='Start' onclick="WbPreset();">
                                </td>
                            </tr>
                            <tr>
                                <td class=td_NormalLeft>&nbsp;Kelvin</td>
                                <td class=td_NormalRight>&nbsp; <select name=AwbMnl>
                                <option value=0>3000K
                                <option value=1>5000K
                                <option value=2>8000K </select> </td>
                            </tr>
                            <tr>
                                <td class=td_NormalLeft>&nbsp;Manual RGain</td>
                                <td class=td_NormalRight>&nbsp; <input type=text name=Rgain size=4 maxlength=2 class=obj_Normal> (Default:10, 0 ~ 20)</td>
                            </tr>
                            <tr>
                                <td class=td_NormalLeft>&nbsp;Manual BGain</td>
                                <td class=td_NormalRight>&nbsp; <input type=text name=Bgain size=4 maxlength=2 class=obj_Normal> (Default:10, 0 ~ 20)</td>
                            </tr>
                            <tr>
                                <td class=td_NormalLeft>&nbsp;Color Gain</td>
                                <td class=td_NormalRight>&nbsp; <input type=text name=Saturation size=4 maxlength=2 class=obj_Normal> 
                            <% FwGetHwOptionRemark("29,30","1&N","BEGIN","NOTEXISTENCE"); %>(Default:5, 0 ~ 20)
                            <% FwGetHwOptionRemark("29,30","1&N","END","NOTEXISTENCE"); %>
                            <% FwGetHwOptionRemark("29,30","1&N","BEGIN","EXISTENCE"); %>(Default:10, 0 ~ 20)
                            <% FwGetHwOptionRemark("29,30","1&N","END","EXISTENCE"); %></td>
                            </tr>
                            <tr>
                                <td class=td_NormalLeft>&nbsp;DNR Level</td>
                                <td class=td_NormalRight>&nbsp; <select name=Adnr>
                                <option value=0>Off
                                <option value=1>Low
                                <option value=2>Middle
                                <option value=3>High </select> </td>
                            </tr>
                        </table>
                    </td>
                </tr>
            </table>
        </td>
    </tr>
    <tr>
        <td align=center height=40>
            <input type="hidden" name="CamCtlPage">
            <input type=hidden name='FwCgiVer' value='0x0001'>
            <input type=hidden name='FwMkChg' value='YES'>
            <input type=hidden name='RetPage' value='/admin/ret_ok.asp'>
            <input type=submit name=toapply value=' Apply ' class=obj_Button>&nbsp;
        </td>
    </tr>
</table>
</form>
</body>
</html>
