<html>
<head>
    <% FwIncludeFile("/web/charset.txt"); %>
    <meta http-equiv="pragma" content="no-cache">
    <link rel="stylesheet" href="/style.css" type="text/css">
    <script src="/js/jquery-3.6.0.min.js" type="text/javascript"></script>
    <script language=javascript>
    <% FwGetModuleInfo("FwModId"); %>
    <% FwVideoModeGet("FwModId"); %>
    <% FwCameraGet("FwModId","PortId","NO_SNAP"); %>

    function checkCR(evt) {
        var evt = (evt) ? evt : ((event) ? event : null);
        var node = (evt.target) ? evt.target : ((evt.srcElement) ? evt.srcElement : null);
        if ((evt.keyCode == 13) && (node.type == "text" || (node.type == "radio") || node.type == "checkbox" || node.type == "password")) { return false; }
    }

    document.onkeypress = checkCR;

    function GetData() {
        with(document.forms[0]) {
            FwModId.value = FWMODID;

            VideoFormat[0].checked = (VIDEO_FORMAT_CFG == 3 ? true : false);
            VideoFormat[1].checked = (VIDEO_FORMAT_CFG == 4 ? true : false);

            ImgInc1.checked = ((OPTIONFLAG & (0x01 << 7)) ? true : false);
            ImgInc2.checked = ((OPTIONFLAG & (0x01 << 6)) ? true : false);
            ImgInc3.checked = ((OPTIONFLAG & (0x01 << 5)) ? true : false);
            ImgInc4.checked = ((OPTIONFLAG & (0x01 << 4)) ? true : false);
            ImgInc5.checked = ((OPTIONFLAG & (0x01 << 3)) ? true : false);
            ImgInc6.checked = ((OPTIONFLAG & (0x01 << 2)) ? true : false);

            if ("<% FwGetHwOption("8"); %>" == "a" || "<% FwGetHwOption("8"); %>" == "p" || "<% FwGetHwOption("8"); %>" == "P" || "<% FwGetHwOption("8"); %>" == "f" || "<% FwGetHwOption("8"); %>" == "u") {
                AudioCodec.value = AUDIOCODEC;
            }

            <% FwGetHwOptionRemark("8,8,8,8,8,8","a|p|P|f|q|u","C_BEGIN","NOTEXISTENCE"); %>
            OsdTimeStamp.value = OSDTIMESTAMP;
            <% FwGetHwOptionRemark("8,8,8,8,8,8","a|p|P|f|q|u","C_END","NOTEXISTENCE"); %>
            <% FwGetHwOptionRemark("8,8,8,8,8,8","a|p|P|f|q|u","C_BEGIN","EXISTENCE"); %>
            OsdTimeStamp[0].checked = (OSDTIMESTAMP ? true : false);
            OsdTimeStamp[1].checked = (OSDTIMESTAMP ? false : true);
            <% FwGetHwOptionRemark("8,8,8,8,8,8","a|p|P|f|q|u","C_END","EXISTENCE"); %>

            TvoutEnable[0].checked = (TVOUTENABLE ? true : false);
            TvoutEnable[1].checked = (TVOUTENABLE ? false : true);

            var idx;
            for (idx = 0; idx < Number(<% FwGetHwOption("18"); %>) + 1; idx++)
            {
                if (idx == PORTID)
                {
                    eval("tab" + idx).className = "selectmenu";
                }
                else
                {
                    eval("tab" + idx).className = "menu";
                }
            }
        }
        with(document.forms[1]) {
            FwModId.value = FWMODID;
            PortId.value = PORTID;
            GetFrameRate();
            CamName.value = CAMNAME;
            FrameRate.value = FRAMERATE;
            ImgSize.value = IMGSIZE;
            CodecType.value = CODECTYPE;
            AudioInstalled[0].checked = ((AUDIOINSTALLED == 1) ? true : false);
            AudioInstalled[1].checked = ((AUDIOINSTALLED == 0) ? true : false);

            if (CODECTYPE == 1 || CODECTYPE == 2 || CODECTYPE == 3)
            {
                var Str = "<table align=center class=tbl_Normal cellspacing=0>";
                var MaxBitRateStr;

                if (CODECTYPE == 2)
                {
                    Str += "<tr><td class=td_NormalLeft>&nbsp;H.264 Profile</td> ";
                    Str += "<td class=td_NormalRight>&nbsp;<input type=radio name=EncProfile value=1> Base&nbsp; ";
                    Str += "<input type=radio name=EncProfile value=2> Main&nbsp; ";
                    Str += "<input type=radio name=EncProfile value=4> High </td></tr>";
                }
                else if (CODECTYPE == 3) {
                    Str += "<tr><td class=td_NormalLeft>&nbsp;H.265 Profile</td> ";
                    Str += "<td class=td_NormalRight>&nbsp;<input type=radio name=EncProfile value=2> Main </td></tr> ";
                }

                if (CBRVALUE == 0)
                {
                    Str += "<tr><td class=td_NormalLeft><input type='hidden' name='CbrValue' value=0>&nbsp;Rate Control Mode</td><td class=td_NormalRight> &nbsp;&nbsp;<select name=RateSelect onChange='SwapRate();'>";
                    Str += "<option value=3>CVBR Mode<option value=1>CBR Mode<option value=0>VBR Mode&nbsp;&nbsp;&nbsp;&nbsp;</select></td></tr>";
                    Str += "<tr><td class=td_NormalLeft>&nbsp;Image Quality</td><td class=td_NormalRight> &nbsp;&nbsp;<select name=Quality>";
                    Str += "<option value=0>Low Compression&nbsp;&nbsp; <option value=1>Highest <option value=2>High <option value=3>Normal ";
                    Str += "<option value=4>Low <option value=5>Lowest </select></td></tr>";
                    Str += "<tr><td class=td_NormalLeft>&nbsp;GOP Structure</td><td class=td_NormalRight> &nbsp;&nbsp;<input type=text name=GopValue size=7 maxlength=2 class=obj_Normal onChange='CheckMinMax(GopValue,1,64);'> [1~64]</td></tr></table>";
                    
                    document.all.Stream_Str.innerHTML = Str;
                    RateSelect.value = 0;
                    Quality.value = QUALITY;
                    GopValue.value = GOPVALUE;
                }
                else if (CBRVALUE == 64)
                {
                    Str += "<input type='hidden' name='CbrValue' value=64><tr><td class=td_NormalLeft>&nbsp;Rate Control Mode</td><td class=td_NormalRight> &nbsp;&nbsp;<select name=RateSelect onChange='SwapRate();'>";
                    Str += "<option value=3>CVBR Mode<option value=1>CBR Mode<option value=0>VBR Mode&nbsp;&nbsp;&nbsp;&nbsp;</select></td></tr>";
                    Str += "<tr><td class=td_NormalLeft>&nbsp;Minimum Bitrate</td>";
                    Str += "<td class=td_NormalRight> &nbsp;&nbsp;<select name=MinAvbrBitRate0>";
                    Str += "<option value=0>0 &nbsp;&nbsp;&nbsp; Kbps&nbsp;&nbsp; <option value=1>100 Kbps <option value=2>200 Kbps <option value=3>300 Kbps <option value=4>400 Kbps <option value=5>500 Kbps <option value=6>600 Kbps";
                    Str += "<option value=7>700 Kbps <option value=8>800 Kbps <option value=9>900 Kbps <option value=10>1.0 Mbps <option value=20>2.0 Mbps <option value=30>3.0 Mbps <option value=40>4.0 Mbps";
                    Str += "<option value=50>5.0 Mbps <option value=60>6.0 Mbps <option value=70>7.0 Mbps <option value=80>8.0 Mbps <option value=90>9.0 Mbps <option value=100>10 &nbsp;Mbps";
                    
                    switch(eval(CBRVALUE))
                    {
                        case 33 :
                        case 34 :
                        case 35 :
                        case 36 :
                        case 37 :
                            MaxBitRateStr = "<tr><td class=td_NormalLeft>&nbsp;Maximum Bitrate</td><td class=td_NormalRight> &nbsp;&nbsp;<select name=MaxCvbrRatio> <option value=1>Target Bitrate + 1 Mbps <option value=2>Target Bitrate + 2 Mbps <option value=3>Target Bitrate + 3 Mbps <option value=4>Target Bitrate + 4 Mbps";
                            MaxBitRateStr += "<option value=5>Target Bitrate + 5 Mbps <option value=6>Target Bitrate + 6 Mbps <option value=7>Target Bitrate + 7 Mbps <option value=8>Target Bitrate + 8 Mbps <option value=9>Target Bitrate + 9 Mbps <option value=10>Target Bitrate + 10 Mbps</select></td></tr>";
                            break;
                        case 38 :
                        case 39 :
                        case 40 :
                        case 41 :
                        case 42 :
                        case 43 :
                            MaxBitRateStr = "<tr><td class=td_NormalLeft>&nbsp;Maximum Bitrate</td><td class=td_NormalRight> &nbsp;&nbsp;<select name=MaxCvbrRatio> <option value=2>Target Bitrate + 2 Mbps <option value=3>Target Bitrate + 3 Mbps <option value=4>Target Bitrate + 4 Mbps";
                            MaxBitRateStr += "<option value=5>Target Bitrate + 5 Mbps <option value=6>Target Bitrate + 6 Mbps <option value=7>Target Bitrate + 7 Mbps <option value=8>Target Bitrate + 8 Mbps <option value=9>Target Bitrate + 9 Mbps <option value=10>Target Bitrate + 10 Mbps</select></td></tr>";
                            break;
                        case 44 :
                        case 45 :
                            MaxBitRateStr = "<tr><td class=td_NormalLeft>&nbsp;Maximum Bitrate</td><td class=td_NormalRight> &nbsp;&nbsp;<select name=MaxCvbrRatio> <option value=3>Target Bitrate + 3 Mbps <option value=4>Target Bitrate + 4 Mbps";
                            MaxBitRateStr += "<option value=5>Target Bitrate + 5 Mbps <option value=6>Target Bitrate + 6 Mbps <option value=7>Target Bitrate + 7 Mbps <option value=8>Target Bitrate + 8 Mbps <option value=9>Target Bitrate + 9 Mbps <option value=10>Target Bitrate + 10 Mbps</select></td></tr>";
                            break;
                        case 46 :
                            MaxBitRateStr = "<tr><td class=td_NormalLeft>&nbsp;Maximum Bitrate</td><td class=td_NormalRight> &nbsp;&nbsp;<select name=MaxCvbrRatio> <option value=4>Target Bitrate + 4 Mbps";
                            MaxBitRateStr += "<option value=5>Target Bitrate + 5 Mbps <option value=6>Target Bitrate + 6 Mbps <option value=7>Target Bitrate + 7 Mbps <option value=8>Target Bitrate + 8 Mbps</select></td></tr>";
                            break;
                        case 47 :
                            MaxBitRateStr = "<tr><td class=td_NormalLeft>&nbsp;Maximum Bitrate</td><td class=td_NormalRight> &nbsp;&nbsp;<select name=MaxCvbrRatio> <option value=4>Target Bitrate + 4 Mbps</select></td></tr>";
                            break;
                        case 64 :
                            MaxBitRateStr = "<tr><td class=td_NormalLeft>&nbsp;Maximum Bitrate</td><td class=td_NormalRight> &nbsp;&nbsp;<select name=MaxCvbrRatio>";
                            MaxBitRateStr += "<option value=0>0 &nbsp;&nbsp;&nbsp; Kbps&nbsp;&nbsp; <option value=1>100 Kbps <option value=2>200 Kbps <option value=3>300 Kbps <option value=4>400 Kbps <option value=5>500 Kbps <option value=6>600 Kbps";
                            MaxBitRateStr += "<option value=7>700 Kbps <option value=8>800 Kbps <option value=9>900 Kbps <option value=10>1.0 Mbps <option value=20>2.0 Mbps <option value=30>3.0 Mbps <option value=40>4.0 Mbps";
                            MaxBitRateStr += "<option value=50>5.0 Mbps <option value=60>6.0 Mbps <option value=70>7.0 Mbps <option value=80>8.0 Mbps <option value=90>9.0 Mbps <option value=100>10 &nbsp;Mbps";
                            MaxBitRateStr += "<option value=130>13 &nbsp;Mbps <option value=160>16 &nbsp;Mbps  <option value=190>19 &nbsp;Mbps <option value=220>22 &nbsp;Mbps <option value=250>25 &nbsp;Mbps</select></td></tr>";
                            break;
                    }

                    Str += MaxBitRateStr;
                    Str += "<tr><td class=td_NormalLeft>&nbsp;GOP Structure</td><td class=td_NormalRight> &nbsp;&nbsp;<input type=text name=GopValue size=7 maxlength=2 class=obj_Normal onChange='CheckMinMax(GopValue,1,64);'> [1~64]</td></tr></table>";

                    document.all.Stream_Str.innerHTML = Str;
                    MaxCvbrRatio.value = MAXCVBRRATIO;
                    MinAvbrBitRate0.value = MINAVBRBITRATE0;
                    RateSelect.selectedIndex = 1;
                    GopValue.value = GOPVALUE;
                }
                else if ((CBRVALUE >= 1) && (CBRVALUE <= 16))
                {
                    Str += "<tr><td class=td_NormalLeft>&nbsp;Rate Control Mode</td><td class=td_NormalRight> &nbsp;&nbsp;<select name=RateSelect onChange='SwapRate();'>";
                    Str += "<option value=3>CVBR Mode<option value=1>CBR Mode<option value=0>VBR Mode&nbsp;&nbsp;&nbsp;&nbsp;</select></td></tr><tr><td class=td_NormalLeft>&nbsp;Target Bitrate</td>";
                    Str += "<td class=td_NormalRight>&nbsp; <select name=CbrValue> <option value=1>32 &nbsp;Kbps&nbsp;&nbsp; <option value=2>64 &nbsp;Kbps <option value=3>128Kbps";
                    Str += "<option value=4>256Kbps <option value=5>512Kbps <option value=6>1.0 Mbps <option value=7>1.5 Mbps <option value=8>2.0 Mbps";
                    Str += "<option value=9>3.0 Mbps <option value=10>4.0 Mbps <option value=11>5.0 Mbps <option value=12>6.0 Mbps <option value=13>8.0 Mbps";
                    Str += "<option value=14>10 Mbps </select></td></tr>";
                    Str += "<tr><td class=td_NormalLeft>&nbsp;GOP Structure</td><td class=td_NormalRight> &nbsp;&nbsp;<input type=text name=GopValue size=7 maxlength=2 class=obj_Normal onChange='CheckMinMax(GopValue,1,64);'> [1~64]</td></tr></table>";
                    
                    document.all.Stream_Str.innerHTML = Str;
                    RateSelect.value = 1;
                    CbrValue.value = CBRVALUE;
                    GopValue.value = GOPVALUE;
                }
                else
                {
                    Str += "<tr><td class=td_NormalLeft>&nbsp;Rate Control Mode</td><td class=td_NormalRight> &nbsp;&nbsp;<select name=RateSelect onChange='SwapRate();'>";
                    Str += "<option value=3>CVBR Mode<option value=1>CBR Mode<option value=0>VBR Mode&nbsp;&nbsp;&nbsp;&nbsp;</select></td></tr><tr><td class=td_NormalLeft>&nbsp;Target Bitrate</td>";
                    Str += "<td class=td_NormalRight> &nbsp;&nbsp;<select name=CbrValue>";
                    Str += "<option value=33>32Kbps <option value=34>64Kbps <option value=35>128Kbps <option value=36>256Kbps <option value=37>512Kbps <option value=38>1.0 Mbps";
                    Str += "<option value=39>1.5 Mbps <option value=40>2.0 Mbps <option value=41>3.0 Mbps <option value=42>4.0 Mbps <option value=43>5.0 Mbps <option value=44>6.0 Mbps";
                    Str += "<option value=45>8.0 Mbps <option value=46>10 Mbps </select></td></tr>";
                    Str += "<tr><td class=td_NormalLeft>&nbsp;GOP Structure</td><td class=td_NormalRight> &nbsp;&nbsp;<input type=text name=GopValue size=7 maxlength=2 class=obj_Normal onChange='CheckMinMax(GopValue,1,64);'> [1~64]</td></tr></table>";

                    document.all.Stream_Str.innerHTML = Str;
                    RateSelect.selectedIndex = 0;
                    
                    CbrValue.value = CBRVALUE;
                    GopValue.value = GOPVALUE;
                }

                if (CODECTYPE == 2)
                {
                    EncProfile[0].checked = ((ENCPROFILE == 1) ? true : false );
                    EncProfile[1].checked = ((ENCPROFILE == 2) ? true : false );
                    EncProfile[2].checked = ((ENCPROFILE == 0 || ENCPROFILE == 4) ? true : false );
                }
                else if (CODECTYPE == 3)
                {
                    EncProfile.checked = ((ENCPROFILE == 2) ? true : false );
                }
            }
            else
            {
                var Str = "<table align=center class=tbl_Normal cellspacing=0>";
                Str += "<tr><td class=td_NormalLeft>&nbsp;Image Quality</td><td class=td_NormalRight> &nbsp;&nbsp;<select name=Quality>";
                Str += "<option value=0>Low Compression&nbsp;&nbsp; <option value=1>Highest <option value=2>High <option value=3>Normal ";
                Str += "<option value=4>Low <option value=5>Lowest </select><input type='hidden' name='CbrValue' value=0></td></tr></table>";

                document.all.Stream_Str.innerHTML = Str;
                Quality.value = QUALITY;
            }
        }
    }

    function GetFrameRate() {
        with(document.all) {
            if (VideoFormat[0].checked == true) {
                var Str = "&nbsp; <select name=FrameRate>";

                if (parseInt(FRAMERATE) >= 10 && parseInt(FRAMERATE) < 128) {
                    StrBasic = "<option value=10>30 fps&nbsp;&nbsp;&nbsp;&nbsp;";
                    StrBasic += "<option value=11>15 fps";
                    StrBasic += "<option value=12>10 fps";
                    StrBasic += "<option value=13>7.5 fps";
                    StrBasic += "<option value=15>5 fps";
                    StrBasic += "<option value=17>3.75 fps";
                    StrBasic += "<option value=19>3 fps";
                    StrBasic += "<option value=24>2 fps";
                    StrBasic += "<option value=39>1 fps </select>"
                } else if (parseInt(FRAMERATE) >= 128) {  
                    StrBasic = "<option value=188>60 fps&nbsp;&nbsp;&nbsp;&nbsp;";
                    StrBasic += "<option value=187>59 fps";
                    StrBasic += "<option value=186>58 fps";
                    StrBasic += "<option value=185>57 fps";
                    StrBasic += "<option value=184>56 fps";
                    StrBasic += "<option value=183>55 fps";
                    StrBasic += "<option value=182>54 fps";
                    StrBasic += "<option value=181>53 fps";
                    StrBasic += "<option value=180>52 fps";
                    StrBasic += "<option value=179>51 fps";
                    StrBasic += "<option value=178>50 fps";
                    StrBasic += "<option value=177>49 fps";
                    StrBasic += "<option value=176>48 fps";
                    StrBasic += "<option value=175>47 fps";
                    StrBasic += "<option value=174>46 fps";
                    StrBasic += "<option value=173>45 fps";
                    StrBasic += "<option value=172>44 fps";
                    StrBasic += "<option value=171>43 fps";
                    StrBasic += "<option value=170>42 fps";
                    StrBasic += "<option value=169>41 fps";
                    StrBasic += "<option value=168>40 fps";
                    StrBasic += "<option value=167>39 fps";
                    StrBasic += "<option value=166>38 fps";
                    StrBasic += "<option value=165>37 fps";
                    StrBasic += "<option value=164>36 fps";
                    StrBasic += "<option value=163>35 fps";
                    StrBasic += "<option value=162>34 fps";
                    StrBasic += "<option value=161>33 fps";
                    StrBasic += "<option value=160>32 fps";
                    StrBasic += "<option value=159>31 fps";
                    StrBasic += "<option value=158>30 fps";
                    StrBasic += "<option value=157>29 fps";
                    StrBasic += "<option value=156>28 fps";
                    StrBasic += "<option value=155>27 fps";
                    StrBasic += "<option value=154>26 fps";
                    StrBasic += "<option value=153>25 fps";
                    StrBasic += "<option value=152>24 fps";
                    StrBasic += "<option value=151>23 fps";
                    StrBasic += "<option value=150>22 fps";
                    StrBasic += "<option value=149>21 fps";
                    StrBasic += "<option value=148>20 fps";
                    StrBasic += "<option value=147>19 fps";
                    StrBasic += "<option value=146>18 fps";
                    StrBasic += "<option value=145>17 fps";
                    StrBasic += "<option value=144>16 fps";
                    StrBasic += "<option value=143>15 fps";
                    StrBasic += "<option value=142>14 fps";
                    StrBasic += "<option value=141>13 fps";
                    StrBasic += "<option value=140>12 fps";
                    StrBasic += "<option value=139>11 fps";
                    StrBasic += "<option value=138>10 fps";
                    StrBasic += "<option value=137>9 fps";
                    StrBasic += "<option value=136>8 fps";
                    StrBasic += "<option value=135>7 fps";
                    StrBasic += "<option value=134>6 fps";
                    StrBasic += "<option value=133>5 fps";
                    StrBasic += "<option value=132>4 fps";
                    StrBasic += "<option value=131>3 fps";
                    StrBasic += "<option value=130>2 fps";
                    StrBasic += "<option value=129>1 fps </select>";
                } else {
                    StrBasic = "<option value=0>30 fps&nbsp;&nbsp;&nbsp;&nbsp;";
                    StrBasic += "<option value=3>15 fps";
                    StrBasic += "<option value=4>7.5 fps";
                    StrBasic += "<option value=5>3.75 fps";
                    StrBasic += "<option value=6>1 fps </select>"
                }

                document.all.FR_Str.innerHTML = Str + StrBasic;
            }
            else
            {
                var Str = "&nbsp; <select name=FrameRate>";

                if (parseInt(FRAMERATE) >= 10 && parseInt(FRAMERATE) < 128) {
                    StrBasic = "<option value=10>25 fps&nbsp;&nbsp;&nbsp;&nbsp;";
                    StrBasic += "<option value=11>12.5 fps";
                    StrBasic += "<option value=12>8.33 fps";
                    StrBasic += "<option value=13>6.25 fps";
                    StrBasic += "<option value=14>5 fps";
                    StrBasic += "<option value=16>3.57 fps";
                    StrBasic += "<option value=19>2.5 fps";
                    StrBasic += "<option value=24>1.67 fps";
                    StrBasic += "<option value=34>1 fps </select>";
                } else if (parseInt(FRAMERATE) >= 128) {
                    StrBasic = "<option value=178>50 fps&nbsp;&nbsp;&nbsp;&nbsp;";
                    StrBasic += "<option value=177>49 fps";
                    StrBasic += "<option value=176>48 fps";
                    StrBasic += "<option value=175>47 fps";
                    StrBasic += "<option value=174>46 fps";
                    StrBasic += "<option value=173>45 fps";
                    StrBasic += "<option value=172>44 fps";
                    StrBasic += "<option value=171>43 fps";
                    StrBasic += "<option value=170>42 fps";
                    StrBasic += "<option value=169>41 fps";
                    StrBasic += "<option value=168>40 fps";
                    StrBasic += "<option value=167>39 fps";
                    StrBasic += "<option value=166>38 fps";
                    StrBasic += "<option value=165>37 fps";
                    StrBasic += "<option value=164>36 fps";
                    StrBasic += "<option value=163>35 fps";
                    StrBasic += "<option value=162>34 fps";
                    StrBasic += "<option value=161>33 fps";
                    StrBasic += "<option value=160>32 fps";
                    StrBasic += "<option value=159>31 fps";
                    StrBasic += "<option value=158>30 fps";
                    StrBasic += "<option value=157>29 fps";
                    StrBasic += "<option value=156>28 fps";
                    StrBasic += "<option value=155>27 fps";
                    StrBasic += "<option value=154>26 fps";
                    StrBasic += "<option value=153>25 fps";
                    StrBasic += "<option value=153>25 fps";
                    StrBasic += "<option value=152>24 fps";
                    StrBasic += "<option value=151>23 fps";
                    StrBasic += "<option value=150>22 fps";
                    StrBasic += "<option value=149>21 fps";
                    StrBasic += "<option value=148>20 fps";
                    StrBasic += "<option value=147>19 fps";
                    StrBasic += "<option value=146>18 fps";
                    StrBasic += "<option value=145>17 fps";
                    StrBasic += "<option value=144>16 fps";
                    StrBasic += "<option value=143>15 fps";
                    StrBasic += "<option value=142>14 fps";
                    StrBasic += "<option value=141>13 fps";
                    StrBasic += "<option value=140>12 fps";
                    StrBasic += "<option value=139>11 fps";
                    StrBasic += "<option value=138>10 fps";
                    StrBasic += "<option value=137>9 fps";
                    StrBasic += "<option value=136>8 fps";
                    StrBasic += "<option value=135>7 fps";
                    StrBasic += "<option value=134>6 fps";
                    StrBasic += "<option value=133>5 fps";
                    StrBasic += "<option value=132>4 fps";
                    StrBasic += "<option value=131>3 fps";
                    StrBasic += "<option value=130>2 fps";
                    StrBasic += "<option value=129>1 fps </select>";
                } else {
                    StrBasic = "<option value=0>25 fps&nbsp;&nbsp;&nbsp;&nbsp;";
                    StrBasic += "<option value=3>12.5 fps";
                    StrBasic += "<option value=4>6.25 fps";
                    StrBasic += "<option value=5>3.13 fps";
                    StrBasic += "<option value=6>1 fps </select>";
                }

                document.all.FR_Str.innerHTML = Str + StrBasic;
            }
        }
    }

    function ChgFrameRate() {
        with(document.all) {
            if (VideoFormat[0].checked == true) {
                var Str = "&nbsp; <select name=FrameRate>";

                if (parseInt(FRAMERATE) >= 10 && parseInt(FRAMERATE) < 128) {
                    StrBasic = "<option value=10>30 fps&nbsp;&nbsp;&nbsp;&nbsp;";
                    StrBasic += "<option value=11>15 fps";
                    StrBasic += "<option value=12>10 fps";
                    StrBasic += "<option value=13>7.5 fps";
                    StrBasic += "<option value=15>5 fps";
                    StrBasic += "<option value=17>3.75 fps";
                    StrBasic += "<option value=19>3 fps";
                    StrBasic += "<option value=24>2 fps";
                    StrBasic += "<option value=39>1 fps </select>"
                } else if (parseInt(FRAMERATE) >= 128) {
                    if ( PORTID == 0 )
                    {
                        StrBasic = "<option value=188>60 fps&nbsp;&nbsp;&nbsp;&nbsp;";
                        StrBasic += "<option value=187>59 fps";
                        StrBasic += "<option value=186>58 fps";
                        StrBasic += "<option value=185>57 fps";
                        StrBasic += "<option value=184>56 fps";
                        StrBasic += "<option value=183>55 fps";
                        StrBasic += "<option value=182>54 fps";
                        StrBasic += "<option value=181>53 fps";
                        StrBasic += "<option value=180>52 fps";
                        StrBasic += "<option value=179>51 fps";
                        StrBasic += "<option value=178>50 fps";
                        StrBasic += "<option value=177>49 fps";
                        StrBasic += "<option value=176>48 fps";
                        StrBasic += "<option value=175>47 fps";
                        StrBasic += "<option value=174>46 fps";
                        StrBasic += "<option value=173>45 fps";
                        StrBasic += "<option value=172>44 fps";
                        StrBasic += "<option value=171>43 fps";
                        StrBasic += "<option value=170>42 fps";
                        StrBasic += "<option value=169>41 fps";
                        StrBasic += "<option value=168>40 fps";
                        StrBasic += "<option value=167>39 fps";
                        StrBasic += "<option value=166>38 fps";
                        StrBasic += "<option value=165>37 fps";
                        StrBasic += "<option value=164>36 fps";
                        StrBasic += "<option value=163>35 fps";
                        StrBasic += "<option value=162>34 fps";
                        StrBasic += "<option value=161>33 fps";
                        StrBasic += "<option value=160>32 fps";
                        StrBasic += "<option value=159>31 fps";
                        StrBasic += "<option value=158>30 fps";
                        StrBasic += "<option value=157>29 fps";
                        StrBasic += "<option value=156>28 fps";
                        StrBasic += "<option value=155>27 fps";
                        StrBasic += "<option value=154>26 fps";
                        StrBasic += "<option value=153>25 fps";
                        StrBasic += "<option value=152>24 fps";
                        StrBasic += "<option value=151>23 fps";
                        StrBasic += "<option value=150>22 fps";
                        StrBasic += "<option value=149>21 fps";
                        StrBasic += "<option value=148>20 fps";
                        StrBasic += "<option value=147>19 fps";
                        StrBasic += "<option value=146>18 fps";
                        StrBasic += "<option value=145>17 fps";
                        StrBasic += "<option value=144>16 fps";
                        StrBasic += "<option value=143>15 fps";
                        StrBasic += "<option value=142>14 fps";
                        StrBasic += "<option value=141>13 fps";
                        StrBasic += "<option value=140>12 fps";
                        StrBasic += "<option value=139>11 fps";
                        StrBasic += "<option value=138>10 fps";
                        StrBasic += "<option value=137>9 fps";
                        StrBasic += "<option value=136>8 fps";
                        StrBasic += "<option value=135>7 fps";
                        StrBasic += "<option value=134>6 fps";
                        StrBasic += "<option value=133>5 fps";
                        StrBasic += "<option value=132>4 fps";
                        StrBasic += "<option value=131>3 fps";
                        StrBasic += "<option value=130>2 fps";
                        StrBasic += "<option value=129>1 fps </select>";
                    }
                    else
                    {
                        StrBasic = "<option value=158>30 fps&nbsp;&nbsp;&nbsp;&nbsp;";
                        StrBasic += "<option value=157>29 fps";
                        StrBasic += "<option value=156>28 fps";
                        StrBasic += "<option value=155>27 fps";
                        StrBasic += "<option value=154>26 fps";
                        StrBasic += "<option value=153>25 fps";
                        StrBasic += "<option value=152>24 fps";
                        StrBasic += "<option value=151>23 fps";
                        StrBasic += "<option value=150>22 fps";
                        StrBasic += "<option value=149>21 fps";
                        StrBasic += "<option value=148>20 fps";
                        StrBasic += "<option value=147>19 fps";
                        StrBasic += "<option value=146>18 fps";
                        StrBasic += "<option value=145>17 fps";
                        StrBasic += "<option value=144>16 fps";
                        StrBasic += "<option value=143>15 fps";
                        StrBasic += "<option value=142>14 fps";
                        StrBasic += "<option value=141>13 fps";
                        StrBasic += "<option value=140>12 fps";
                        StrBasic += "<option value=139>11 fps";
                        StrBasic += "<option value=138>10 fps";
                        StrBasic += "<option value=137>9 fps";
                        StrBasic += "<option value=136>8 fps";
                        StrBasic += "<option value=135>7 fps";
                        StrBasic += "<option value=134>6 fps";
                        StrBasic += "<option value=133>5 fps";
                        StrBasic += "<option value=132>4 fps";
                        StrBasic += "<option value=131>3 fps";
                        StrBasic += "<option value=130>2 fps";
                        StrBasic += "<option value=129>1 fps </select>";
                    }
                } else {
                    StrBasic = "<option value=0>30 fps&nbsp;&nbsp;&nbsp;&nbsp;";
                    StrBasic += "<option value=3>15 fps";
                    StrBasic += "<option value=4>7.5 fps";
                    StrBasic += "<option value=5>3.75 fps";
                    StrBasic += "<option value=6>1 fps </select>"
                }

                document.all.FR_Str.innerHTML = Str + StrBasic;
                FrameRate0.value = 158;
                FrameRate1.value = 158;
                FrameRate2.value = 158;
            }
            else
            {
                var Str = "&nbsp; <select name=FrameRate>";

                if (parseInt(FRAMERATE) >= 10 && parseInt(FRAMERATE) < 128) {
                    StrBasic = "<option value=10>25 fps&nbsp;&nbsp;&nbsp;&nbsp;";
                    StrBasic += "<option value=11>12.5 fps";
                    StrBasic += "<option value=12>8.33 fps";
                    StrBasic += "<option value=13>6.25 fps";
                    StrBasic += "<option value=14>5 fps";
                    StrBasic += "<option value=16>3.57 fps";
                    StrBasic += "<option value=19>2.5 fps";
                    StrBasic += "<option value=24>1.67 fps";
                    StrBasic += "<option value=34>1 fps </select>";
                } else if (parseInt(FRAMERATE) >= 128) {
                    if ( PORTID == 0 )
                    {
                        StrBasic = "<option value=178>50 fps&nbsp;&nbsp;&nbsp;&nbsp;";
                        StrBasic += "<option value=177>49 fps";
                        StrBasic += "<option value=176>48 fps";
                        StrBasic += "<option value=175>47 fps";
                        StrBasic += "<option value=174>46 fps";
                        StrBasic += "<option value=173>45 fps";
                        StrBasic += "<option value=172>44 fps";
                        StrBasic += "<option value=171>43 fps";
                        StrBasic += "<option value=170>42 fps";
                        StrBasic += "<option value=169>41 fps";
                        StrBasic += "<option value=168>40 fps";
                        StrBasic += "<option value=167>39 fps";
                        StrBasic += "<option value=166>38 fps";
                        StrBasic += "<option value=165>37 fps";
                        StrBasic += "<option value=164>36 fps";
                        StrBasic += "<option value=163>35 fps";
                        StrBasic += "<option value=162>34 fps";
                        StrBasic += "<option value=161>33 fps";
                        StrBasic += "<option value=160>32 fps";
                        StrBasic += "<option value=159>31 fps";
                        StrBasic += "<option value=158>30 fps";
                        StrBasic += "<option value=157>29 fps";
                        StrBasic += "<option value=156>28 fps";
                        StrBasic += "<option value=155>27 fps";
                        StrBasic += "<option value=154>26 fps";
                        StrBasic += "<option value=153>25 fps";
                        StrBasic += "<option value=153>25 fps";
                        StrBasic += "<option value=152>24 fps";
                        StrBasic += "<option value=151>23 fps";
                        StrBasic += "<option value=150>22 fps";
                        StrBasic += "<option value=149>21 fps";
                        StrBasic += "<option value=148>20 fps";
                        StrBasic += "<option value=147>19 fps";
                        StrBasic += "<option value=146>18 fps";
                        StrBasic += "<option value=145>17 fps";
                        StrBasic += "<option value=144>16 fps";
                        StrBasic += "<option value=143>15 fps";
                        StrBasic += "<option value=142>14 fps";
                        StrBasic += "<option value=141>13 fps";
                        StrBasic += "<option value=140>12 fps";
                        StrBasic += "<option value=139>11 fps";
                        StrBasic += "<option value=138>10 fps";
                        StrBasic += "<option value=137>9 fps";
                        StrBasic += "<option value=136>8 fps";
                        StrBasic += "<option value=135>7 fps";
                        StrBasic += "<option value=134>6 fps";
                        StrBasic += "<option value=133>5 fps";
                        StrBasic += "<option value=132>4 fps";
                        StrBasic += "<option value=131>3 fps";
                        StrBasic += "<option value=130>2 fps";
                        StrBasic += "<option value=129>1 fps </select>";
                    }
                    else
                    {
                        StrBasic = "<option value=153>25 fps&nbsp;&nbsp;&nbsp;&nbsp;";
                        StrBasic += "<option value=152>24 fps";
                        StrBasic += "<option value=151>23 fps";
                        StrBasic += "<option value=150>22 fps";
                        StrBasic += "<option value=149>21 fps";
                        StrBasic += "<option value=148>20 fps";
                        StrBasic += "<option value=147>19 fps";
                        StrBasic += "<option value=146>18 fps";
                        StrBasic += "<option value=145>17 fps";
                        StrBasic += "<option value=144>16 fps";
                        StrBasic += "<option value=143>15 fps";
                        StrBasic += "<option value=142>14 fps";
                        StrBasic += "<option value=141>13 fps";
                        StrBasic += "<option value=140>12 fps";
                        StrBasic += "<option value=139>11 fps";
                        StrBasic += "<option value=138>10 fps";
                        StrBasic += "<option value=137>9 fps";
                        StrBasic += "<option value=136>8 fps";
                        StrBasic += "<option value=135>7 fps";
                        StrBasic += "<option value=134>6 fps";
                        StrBasic += "<option value=133>5 fps";
                        StrBasic += "<option value=132>4 fps";
                        StrBasic += "<option value=131>3 fps";
                        StrBasic += "<option value=130>2 fps";
                        StrBasic += "<option value=129>1 fps </select>";
                    }
                } else {
                    StrBasic = "<option value=0>25 fps&nbsp;&nbsp;&nbsp;&nbsp;";
                    StrBasic += "<option value=3>12.5 fps";
                    StrBasic += "<option value=4>6.25 fps";
                    StrBasic += "<option value=5>3.13 fps";
                    StrBasic += "<option value=6>1 fps </select>";
                }

                document.all.FR_Str.innerHTML = Str + StrBasic;
                FrameRate0.value = 153;
                FrameRate1.value = 153;
                FrameRate2.value = 153;
            }
        }
    }

    function ChgCodecType(){
        with ( document.all) {
            if (CodecType.value == 1 || CodecType.value == 2 || CodecType.value == 3)
            {
                var Str = "";

                if (CodecType.value == 2)
                {
                    Str += "<tr><td class=td_NormalLeft>&nbsp;H.264 Profile</td> ";
                    Str += "<td class=td_NormalRight>&nbsp;<input type=radio name=EncProfile value=1> Base&nbsp; ";
                    Str += "<input type=radio name=EncProfile value=2> Main&nbsp; ";
                    Str += "<input type=radio name=EncProfile value=4> High </td></tr>";
                }
                else if (CodecType.value == 3) {
                    Str += "<tr><td class=td_NormalLeft>&nbsp;H.265 Profile</td> ";
                    Str += "<td class=td_NormalRight>&nbsp;<input type=radio name=EncProfile value=2> Main </td></tr> ";
                }

                Str += "<tr><td class=td_NormalLeft>&nbsp;Rate Control Mode</td><td class=td_NormalRight> &nbsp;&nbsp;<select name=RateSelect onChange='SwapRate();'>";
                Str += "<option value=3>CVBR Mode<option value=1>CBR Mode<option value=0>VBR Mode&nbsp;&nbsp;&nbsp;&nbsp;</select></td></tr><tr><td class=td_NormalLeft>&nbsp;Target Bitrate</td>";
                Str += "<td class=td_NormalRight> &nbsp;&nbsp;<select name=CbrValue> <option value=3>128Kbps";
                Str += "<option value=4>256Kbps <option value=5>512Kbps <option value=6>1.0 Mbps <option value=7>1.5 Mbps <option value=8>2.0 Mbps";
                Str += "<option value=9>3.0 Mbps <option value=10>4.0 Mbps <option value=11>5.0 Mbps <option value=12>6.0 Mbps <option value=13>8.0 Mbps </select></td></tr>";
                Str += "<tr><td class=td_NormalLeft>&nbsp;GOP Structure</td><td class=td_NormalRight> &nbsp;&nbsp;<input type=text name=GopValue size=7 maxlength=2 class=obj_Normal onChange='CheckMinMax(GopValue,1,64);'> [1~64]</td></tr>";
                
                document.all.Stream_Str.innerHTML = Str;

                RateSelect.value = 1;
                if ((CBRVALUE >= 1) && (CBRVALUE <= 16)){
                    CbrValue.value = CBRVALUE;
                }
                else{
                    CbrValue.value = 6;
                }
                GopValue.value = GOPVALUE;

                if (CodecType.value == 2)
                {
                    EncProfile[2].checked = true;
                }
                else if (CodecType.value == 3)
                {
                    EncProfile.checked = true;
                }
            }
            else
            {
                var Str = "";
                Str += "<tr><td class=td_NormalLeft>&nbsp;Image Quality</td><td class=td_NormalRight> &nbsp;&nbsp;<select name=Quality>";
                Str += "<option value=0>Low Compression&nbsp;&nbsp; <option value=1>Highest <option value=2>High <option value=3>Normal ";
                Str += "<option value=4>Low <option value=5>Lowest </select><input type='hidden' name='CbrValue' value=0></td></tr>";

                document.all.Stream_Str.innerHTML = Str;
                Quality.value = QUALITY;
            }
        }
    }

    function SwapRate() {
        with ( document.all ) {
            if (RateSelect.value == 3)
            {
                var Str = "";

                if (CodecType.value == 2)
                {
                    Str += "<tr><td class=td_NormalLeft>&nbsp;H.264 Profile</td> ";
                    Str += "<td class=td_NormalRight>&nbsp;<input type=radio name=EncProfile value=1> Base&nbsp; ";
                    Str += "<input type=radio name=EncProfile value=2> Main&nbsp; ";
                    Str += "<input type=radio name=EncProfile value=4> High </td></tr>";
                }
                else if (CodecType.value == 3) {
                    Str += "<tr><td class=td_NormalLeft>&nbsp;H.265 Profile</td> ";
                    Str += "<td class=td_NormalRight>&nbsp;<input type=radio name=EncProfile value=2> Main&nbsp;</td></tr>";
                }

                Str += "<tr><td class=td_NormalLeft>&nbsp;Rate Control Mode</td><td class=td_NormalRight>&nbsp; <select name=RateSelect onChange='SwapRate();'>";
                Str += "<option value=3>CVBR Mode<option value=1>CBR Mode<option value=0>VBR Mode&nbsp;&nbsp;&nbsp;&nbsp;</select></td></tr><tr><td class=td_NormalLeft>&nbsp;Target Bitrate</td>";
                Str += "<td class=td_NormalRight> &nbsp;&nbsp;<select name=CbrValue>";
                Str += "<option value=33>32Kbps <option value=34>64Kbps <option value=35>128Kbps <option value=36>256Kbps <option value=37>512Kbps <option value=38>1.0 Mbps";
                Str += "<option value=39>1.5 Mbps <option value=40>2.0 Mbps <option value=41>3.0 Mbps <option value=42>4.0 Mbps <option value=43>5.0 Mbps <option value=44>6.0 Mbps";
                Str += "<option value=45>8.0 Mbps <option value=46>10 Mbps </select></td></tr>";
                Str += "<tr><td class=td_NormalLeft>&nbsp;GOP Structure</td><td class=td_NormalRight> &nbsp;&nbsp;<input type=text name=GopValue size=7 maxlength=2 class=obj_Normal onChange='CheckMinMax(GopValue,1,64);'> [1~64]</td></tr>";

                document.all.Stream_Str.innerHTML = Str;

                RateSelect.value = 3;
                CbrValue.value = 38;
                GopValue.value = GOPVALUE;

                if (CodecType.value == 2)
                {
                    EncProfile[0].checked = ((ENCPROFILE == 1) ? true : false );
                    EncProfile[1].checked = ((ENCPROFILE == 2) ? true : false );
                    EncProfile[2].checked = ((ENCPROFILE == 0 || ENCPROFILE == 4) ? true : false );
                }
                else if (CodecType.value == 3)
                {
                    EncProfile.checked = true;
                }
            }
            else if (RateSelect.value == 2)
            {
                var Str = "<input type='hidden' name='CbrValue' value=64>";

                if (CodecType.value == 2)
                {
                    Str += "<tr><td class=td_NormalLeft>&nbsp;H.264 Profile</td> ";
                    Str += "<td class=td_NormalRight>&nbsp;<input type=radio name=EncProfile value=1> Base&nbsp; ";
                    Str += "<input type=radio name=EncProfile value=2> Main&nbsp; ";
                    Str += "<input type=radio name=EncProfile value=4> High </td></tr>";
                }
                else if (CodecType.value == 3) {
                    Str += "<tr><td class=td_NormalLeft>&nbsp;H.265 Profile</td> ";
                    Str += "<td class=td_NormalRight>&nbsp;<input type=radio name=EncProfile value=2> Main&nbsp;</td></tr>";
                }

                Str += "<tr><td class=td_NormalLeft>&nbsp;Rate Control Mode</td><td class=td_NormalRight> &nbsp;&nbsp;<select name=RateSelect onChange='SwapRate();'>";
                Str += "<option value=3>CVBR Mode<option value=1>CBR Mode<option value=0>VBR Mode&nbsp;&nbsp;&nbsp;&nbsp;</select></td></tr>";
                Str += "<tr><td class=td_NormalLeft>&nbsp;Minimum Bitrate</td>";
                Str += "<td class=td_NormalRight> &nbsp;&nbsp;<select name=MinAvbrBitRate0>";
                Str += "<option value=0>0 &nbsp;&nbsp;&nbsp; Kbps&nbsp;&nbsp; <option value=1>100 Kbps <option value=2>200 Kbps <option value=3>300 Kbps <option value=4>400 Kbps <option value=5>500 Kbps <option value=6>600 Kbps";
                Str += "<option value=7>700 Kbps <option value=8>800 Kbps <option value=9>900 Kbps <option value=10>1.0 Mbps <option value=20>2.0 Mbps <option value=30>3.0 Mbps <option value=40>4.0 Mbps";
                Str += "<option value=50>5.0 Mbps <option value=60>6.0 Mbps <option value=70>7.0 Mbps <option value=80>8.0 Mbps <option value=90>9.0 Mbps <option value=100>10 &nbsp;Mbps";
                Str += "<option value=130>13 &nbsp;Mbps <option value=160>16 &nbsp;Mbps  <option value=190>19 &nbsp;Mbps <option value=220>22 &nbsp;Mbps <option value=250>25 &nbsp;Mbps</select></td></tr>";
                Str += "<tr><td class=td_NormalLeft>&nbsp;Maximum Bitrate</td><td class=td_NormalRight> &nbsp;&nbsp;<select name=MaxCvbrRatio>";
                Str += "<option value=0>0 &nbsp;&nbsp;&nbsp; Kbps&nbsp;&nbsp; <option value=1>100 Kbps <option value=2>200 Kbps <option value=3>300 Kbps <option value=4>400 Kbps <option value=5>500 Kbps <option value=6>600 Kbps";
                Str += "<option value=7>700 Kbps <option value=8>800 Kbps <option value=9>900 Kbps <option value=10>1.0 Mbps <option value=20>2.0 Mbps <option value=30>3.0 Mbps <option value=40>4.0 Mbps";
                Str += "<option value=50>5.0 Mbps <option value=60>6.0 Mbps <option value=70>7.0 Mbps <option value=80>8.0 Mbps <option value=90>9.0 Mbps <option value=100>10 &nbsp;Mbps";
                Str += "<option value=130>13 &nbsp;Mbps <option value=160>16 &nbsp;Mbps  <option value=190>19 &nbsp;Mbps <option value=220>22 &nbsp;Mbps <option value=250>25 &nbsp;Mbps</select></td></tr>";
                Str += "<tr><td class=td_NormalLeft>&nbsp;GOP Structure</td><td class=td_NormalRight> &nbsp;&nbsp;<input type=text name=GopValue size=7 maxlength=2 class=obj_Normal onChange='CheckMinMax(GopValue,1,64);'> [1~64]</td></tr></table>";

                document.all.Stream_Str.innerHTML = Str;

                MaxCvbrRatio.value = 30;
                MinAvbrBitRate0.value = 10;
                RateSelect.value = 2;
                GopValue.value = GOPVALUE;

                if (CodecType.value == 2)
                {
                    EncProfile[0].checked = ((ENCPROFILE == 1) ? true : false );
                    EncProfile[1].checked = ((ENCPROFILE == 2) ? true : false );
                    EncProfile[2].checked = ((ENCPROFILE == 0 || ENCPROFILE == 4) ? true : false );
                }
                else if (CodecType.value == 3)
                {
                    EncProfile.checked = true;
                }
            }
            else if (RateSelect.value == 1)
            {
                var Str = "";

                if (CodecType.value == 2)
                {
                    Str += "<tr><td class=td_NormalLeft>&nbsp;H.264 Profile</td> ";
                    Str += "<td class=td_NormalRight>&nbsp;<input type=radio name=EncProfile value=1> Base&nbsp; ";
                    Str += "<input type=radio name=EncProfile value=2> Main&nbsp; ";
                    Str += "<input type=radio name=EncProfile value=4> High </td></tr>";
                }
                else if (CodecType.value == 3) {
                    Str += "<tr><td class=td_NormalLeft>&nbsp;H.265 Profile</td> ";
                    Str += "<td class=td_NormalRight>&nbsp;<input type=radio name=EncProfile value=2> Main&nbsp;</td></tr>";
                }

                Str += "<tr><td class=td_NormalLeft>&nbsp;Rate Control Mode</td><td class=td_NormalRight>&nbsp; <select name=RateSelect onChange='SwapRate();'>";
                Str += "<option value=3>CVBR Mode<option value=1>CBR Mode<option value=0>VBR Mode&nbsp;&nbsp;&nbsp;&nbsp;</select></td></tr><tr><td class=td_NormalLeft>&nbsp;Target Bitrate</td>";
                Str += "<td class=td_NormalRight>&nbsp; <select name=CbrValue> <option value=1>32 &nbsp;Kbps&nbsp;&nbsp; <option value=2>64 &nbsp;Kbps <option value=3>128Kbps";
                Str += "<option value=4>256Kbps <option value=5>512Kbps <option value=6>1.0 Mbps <option value=7>1.5 Mbps <option value=8>2.0 Mbps";
                Str += "<option value=9>3.0 Mbps <option value=10>4.0 Mbps <option value=11>5.0 Mbps <option value=12>6.0 Mbps <option value=13>8.0 Mbps";
                Str += "<option value=14>10 Mbps </select></td></tr>";
                Str += "<tr><td class=td_NormalLeft>&nbsp;GOP Structure</td><td class=td_NormalRight>&nbsp; <input type=text name=GopValue size=7 maxlength=2 class=obj_Normal onChange='CheckMinMax(GopValue,1,64);'> [1~64]</td></tr>";

                document.all.Stream_Str.innerHTML = Str;

                RateSelect.value = 1;
                if ((CBRVALUE >= 1) && (CBRVALUE <= 16)){
                    CbrValue.value = CBRVALUE;
                }
                else{
                    CbrValue.value = 6;
                }
                GopValue.value = GOPVALUE;

                if (CodecType.value == 2)
                {
                    EncProfile[0].checked = ((ENCPROFILE == 1) ? true : false );
                    EncProfile[1].checked = ((ENCPROFILE == 2) ? true : false );
                    EncProfile[2].checked = ((ENCPROFILE == 0 || ENCPROFILE == 4) ? true : false );
                }
                else if (CodecType.value == 3)
                {
                    EncProfile.checked = true;
                }
            }
            else
            {
                var Str = "<input type='hidden' name='CbrValue' value=0>";

                if (CodecType.value == 2)
                {
                    Str += "<tr><td class=td_NormalLeft>&nbsp;H.264 Profile</td> ";
                    Str += "<td class=td_NormalRight>&nbsp;<input type=radio name=EncProfile value=1> Base&nbsp; ";
                    Str += "<input type=radio name=EncProfile value=2> Main&nbsp; ";
                    Str += "<input type=radio name=EncProfile value=4> High </td></tr>";
                }
                else if (CodecType.value == 3) {
                    Str += "<tr><td class=td_NormalLeft>&nbsp;H.265 Profile</td> ";
                    Str += "<td class=td_NormalRight>&nbsp;<input type=radio name=EncProfile value=2> Main&nbsp;</td></tr>";
                }

                Str += "<tr><td class=td_NormalLeft>&nbsp;Rate Control Mode</td><td class=td_NormalRight>&nbsp; <select name=RateSelect onChange='SwapRate();'>";
                Str += "<option value=3>CVBR Mode<option value=1>CBR Mode<option value=0>VBR Mode&nbsp;&nbsp;&nbsp;&nbsp;</select></td></tr>";
                Str += "<tr><td class=td_NormalLeft>&nbsp;Image Quality</td><td class=td_NormalRight> &nbsp;&nbsp;<select name=Quality>";
                Str += "<option value=0>Low Compression&nbsp;&nbsp; <option value=1>Highest <option value=2>High <option value=3>Normal ";
                Str += "<option value=4>Low <option value=5>Lowest </select></td></tr>";
                Str += "<tr><td class=td_NormalLeft>&nbsp;GOP Structure</td><td class=td_NormalRight>&nbsp; <input type=text name=GopValue size=7 maxlength=2 class=obj_Normal onChange='CheckMinMax(GopValue,1,64);'> [1~64]</td></tr>";

                document.all.Stream_Str.innerHTML = Str;

                RateSelect.value = 0;
                CbrValue.value = 0;
                Quality.value = QUALITY;
                GopValue.value = GOPVALUE;

                if (CodecType.value == 2)
                {
                    EncProfile[0].checked = ((ENCPROFILE == 1) ? true : false );
                    EncProfile[1].checked = ((ENCPROFILE == 2) ? true : false );
                    EncProfile[2].checked = ((ENCPROFILE == 0 || ENCPROFILE == 4) ? true : false );
                }
                else if (CodecType.value == 3)
                {
                    EncProfile.checked = true;
                }
            }
        }
    }

    function CheckMinMax(inpobj,GetMin,GetMax) {
        if(isNaN(Number(inpobj.value,10))){
            alert("\'" + inpobj.value + "\' is not a number");
            inpobj.focus();
        }
        if(inpobj.value < GetMin || inpobj.value > GetMax){
            alert("Value should be " + GetMin + " ~ " + GetMax );
            inpobj.focus();
        }
    }

    function VideoSubmit() {
        with(document.all) {
            Flag =  (ImgInc1.checked << 7) |
                    (ImgInc2.checked << 6) |
                    (ImgInc3.checked << 5) |
                    (ImgInc4.checked << 4) |
                    (ImgInc5.checked << 3) |
                    (ImgInc6.checked << 2);

            Flag =  (ImgInc1.checked << 7) |
                    (ImgInc2.checked << 6) |
                    (ImgInc3.checked << 5) |
                    (ImgInc4.checked << 4) |
                    (ImgInc5.checked << 3) |
                    (ImgInc6.checked << 2);

            OptionFlag.value = Flag;

            tovideo.disabled = true;
            tovideoport.disabled = true;

            video.submit();
        }
    }

    function VideoPortSubmit() {
        with(document.all) {
            if(CamName.value == "") {
                alert("Please enter camera name.");
                CamName.focus();
                return false;
            }    
            else {
                var intLength = CamName.value.length;        
                for (var i = 0; i < intLength; i++){
                    var charCode = CamName.value.charCodeAt(i);
                    if (charCode == 34 || charCode == 35 || charCode == 39 || charCode == 58 || charCode == 59 || charCode == 92) {
                        alert("The camera name must be alphanumeric.");
                        CamName.focus();
                        CamName.select();
                        return false;
                    }
                }            
            
                var strCharCounter = 0;
                var intLength = CamName.value.length;        
                for (var i = 0; i < intLength; i++){
                    var charCode = CamName.value.charCodeAt(i);
                    if (charCode > 128) {
                        strCharCounter += 2;
                    }
                    if (charCode < 128) {
                        strCharCounter += 1;
                    }             
                }                
                if(strCharCounter > 21) {
                    alert("The camera name can be 21 alphanumeric or 10 unicode.");
                    CamName.focus();
                    return false;
                }                            
            }

            if (CodecType.value == 2)
            {
                if((GopValue.value < 1) || (64 < GopValue.value)) { 
                    alert("Value should be in the range."); 
                    GopValue.focus();
                    return false;
                } 
                if(isNaN(Number(GopValue.value))){
                    alert("\'" + GopValue.value + "\' is not a number");
                    GopValue.focus();
                    return false;
                }
            }
            
            tovideo.disabled = true;
            tovideoport.disabled = true;

            videoport.submit();
        }
    }

    function ChgTab(TARGET) {
        with (document.all) {
            location.href = "/admin/camera/videocfg_<% FwGetSensorTypeMapping(); %>.asp?FwModId=0&PortId=" + TARGET;
//          location.href = "/admin/camera/simple_videocfg_2m30f_chg.asp?FwModId=0&PortId=" + TARGET;
        }
    }

    </script>
</head>

<body class=body_Normal OnLoad="GetData();" topmargin=30>
    <table border=0 cellpadding=0 cellspacing=0 align=center>
        <tr>
            <td align=center height=40>
                <font class=text_Title>Stream Setup</font>
            </td>
        </tr>
        <tr>
            <td align=center>
                <form name=video method=Post action="/cgi-bin/admin/fwvmdset.cgi">
                    <table width="450" class=tbl_Normal cellspacing=0>
                        <tr>
                            <td colspan=2 class=td_NormalLeft>&nbsp;Max Frame Rate</td>
                            <td class=td_NormalRight>&nbsp;
                                <input type=radio name=VideoFormat value=3 onClick="ChgFrameRate();"> 60 fps
                                <input type=radio name=VideoFormat value=4 onClick="ChgFrameRate();"> 50 fps</td>
                        </tr>
                        <tr>
                            <td colspan="2" class=td_NormalLeft>&nbsp;Video with Flexible Extra System data</td>
                            <td class=td_NormalRight>&nbsp;
                                <input type=checkbox name=ImgInc1> Enable
                            </td>
                        </tr>
                        <tr>
                            <td colspan="2" class=td_NormalLeft>&nbsp;Video with user defined message&nbsp;</td>
                            <td class=td_NormalRight>&nbsp;
                                <input type=checkbox name=ImgInc2> Enable
                            </td>
                        </tr>
                        <tr>
                            <td colspan="2" class=td_NormalLeft>&nbsp;Video with PPP status</td>
                            <td class=td_NormalRight>&nbsp;
                                <input type=checkbox name=ImgInc3> Enable
                            </td>
                        </tr>
                        <tr>
                            <td colspan=2 class=td_NormalLeft>&nbsp;Video with camera name</td>
                            <td class=td_NormalRight>&nbsp;
                                <input type=checkbox name=ImgInc4> Enable
                            </td>
                        </tr>
                        <tr>
                            <td colspan=2 class=td_NormalLeft>&nbsp;Video with server name</td>
                            <td class=td_NormalRight>&nbsp;
                                <input type=checkbox name=ImgInc5> Enable
                            </td>
                        </tr>
                        <tr>
                            <td colspan=2 class=td_NormalLeft>&nbsp;Video with IP address</td>
                            <td class=td_NormalRight>&nbsp;
                                <input type=checkbox name=ImgInc6> Enable
                            </td>
                        </tr>
                        <% FwGetHwOptionRemark("8,8,8,8,8,8","a|p|P|f|q|u","BEGIN","NOTEXISTENCE"); %>
                        <tr>
                            <td colspan=2 class=td_NormalLeft>&nbsp;Time Stamp</td>
                            <td class=td_NormalRight>&nbsp;
                                <select name=OsdTimeStamp>
                                    <option value=0>Off
                                    <option value=1>ISO Standard
                                    <option value=2>American Numeric
                                    <option value=3>British Numeric
                                    <option value=4>American Alphanumeric
                                    <option value=5>British Alphanumeric
                                </select>
                            </td>
                        </tr>
                        <% FwGetHwOptionRemark("8,8,8,8,8,8","a|p|P|f|q|u","END","NOTEXISTENCE"); %>
                        <% FwGetHwOptionRemark("8,8,8,8,8,8","a|p|P|f|q|u","BEGIN","EXISTENCE"); %>
                        <tr>
                            <td colspan=2 class=td_NormalLeft>&nbsp;Time Stamp</td>
                            <td class=td_NormalRight>&nbsp;
                                <input type=radio name=OsdTimeStamp value=1> On&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                <input type=radio name=OsdTimeStamp value=0> Off</td>
                        </tr>
                        <% FwGetHwOptionRemark("8,8,8,8,8,8","a|p|P|f|q|u","END","EXISTENCE"); %>
                        <tr>
                            <td colspan=2 class=td_NormalLeft>&nbsp;TV Out</td>
                            <td class=td_NormalRight>&nbsp;
                                <input type=radio name=TvoutEnable value=1>Enable
                                <input type=radio name=TvoutEnable value=0> Disable</td>
                        </tr>
                        <% FwGetHwOptionRemark("8,8,8,8,8,8","a|p|P|f|q|u","BEGIN","NOTEXISTENCE"); %>
                        <tr>
                            <script language=javascript>
                            if ("<% FwGetHwOption("28"); %>" == "0")
                            {
                                if ("<% FwGetHwOption("43"); %>" == "2")
                                {
                                    document.write("<td colspan='2' class=td_NormalLeft>&nbsp;Audio Codec</td> " +
                                        "<td class=td_NormalRight>&nbsp; <select name=AudioCodec disabled> " +
                                        "<option value=1>G.711 &micro;-LAW " +
                                        //"<option value=2>G.711 A-LAW &nbsp;&nbsp;&nbsp;&nbsp;&nbsp; " +
                                        "</select></td>");
                                }
                                else
                                {
                                    document.write("<td colspan='2' class=td_NormalLeft>&nbsp;Audio Codec</td> " +
                                        "<td class=td_NormalRight>&nbsp; <select name=AudioCodec disabled> " +
                                        "<option value=1>G.711 &micro;-LAW " +
                                        //"<option value=2>G.711 A-LAW &nbsp;&nbsp;&nbsp;&nbsp;&nbsp; " +
                                        "</select></td>");
                                }
                            }
                            else
                            {
                                if ("<% FwGetHwOption("43"); %>" == "2")
                                {
                                    document.write("<td colspan='2' class=td_NormalLeft>&nbsp;Audio Codec</td> " +
                                        "<td class=td_NormalRight>&nbsp; <select name=AudioCodec> " +
                                        "<option value=1>G.711 &micro;-LAW " +
                                        //"<option value=2>G.711 A-LAW &nbsp;&nbsp;&nbsp;&nbsp;&nbsp; " +
                                        "</select></td>");
                                }
                                else
                                {
                                    document.write("<td colspan='2' class=td_NormalLeft>&nbsp;Audio Codec</td> " +
                                        "<td class=td_NormalRight>&nbsp; <select name=AudioCodec> " +
                                        "<option value=1>G.711 &micro;-LAW " +
                                        //"<option value=2>G.711 A-LAW &nbsp;&nbsp;&nbsp;&nbsp;&nbsp; " +
                                        "</select></td>");
                                }                            
                            }
                            </script>
                        </tr>
                        <% FwGetHwOptionRemark("8,8,8,8,8,8","a|p|P|f|q|u","END","NOTEXISTENCE"); %>
                        <tr>
                            <td colspan=3 align=center height=40>
                                <input type=hidden name="FwModId">
                                <input type=hidden name="OptionFlag">
                                <input type=hidden name="FrameRate0">
                                <input type=hidden name="FrameRate1">
                                <input type=hidden name="FrameRate2">
                                <input type=hidden name='FwCgiVer' value='0x0001'>
                                <input type=hidden name='FwMkChg' value='YES'>
                                <input type=hidden name='RetPage' value='/admin/ret_ok.asp'>
                                <input type=button class=obj_Button name=tovideo value=" Apply " onclick="VideoSubmit();">
                            </td>
                        </tr>
                    </table>
                </form>
            </td>
        </tr>
        <tr>
            <td height=20></td>
        </tr>
        <tr>
            <td>
                <form name=videoport method=Post action="/cgi-bin/admin/fwcamset.cgi">
                    <table width=450 align=center class=tbl_Normal cellspacing=0>
                        <tr>
                            <td colspan=2 align=left height=25>&nbsp;
                                <% FwGetHwOptionRemark("18","0","BEGIN","NOTEXISTENCE"); %>
                                <a id="tab0" href='javascript:void(0);' class=menu onclick="ChgTab(0);">Primary</a> &nbsp;
                                <% FwGetHwOptionRemark("18","0","END","NOTEXISTENCE"); %>
                                <% FwGetHwOptionRemark("18","1","BEGIN","NOTEXISTENCE"); %>
                                <a id="tab0" href='javascript:void(0);' class=menu onclick="ChgTab(0);">Primary</a> &nbsp;<b>|</b>&nbsp;
                                <a id="tab1" href='javascript:void(0);' class=menu onclick="ChgTab(1);">Secondary</a> &nbsp;
                                <% FwGetHwOptionRemark("18","1","END","NOTEXISTENCE"); %>
                                <% FwGetHwOptionRemark("18","2","BEGIN","NOTEXISTENCE"); %>
                                <a id="tab0" href='javascript:void(0);' class=menu onclick="ChgTab(0);">Primary</a> &nbsp;<b>|</b>&nbsp;
                                <a id="tab1" href='javascript:void(0);' class=menu onclick="ChgTab(1);">Secondary</a> &nbsp;<b>|</b>&nbsp;
                                <a id="tab2" href='javascript:void(0);' class=menu onclick="ChgTab(2);">Tertiary</a> &nbsp;
                                <% FwGetHwOptionRemark("18","2","END","NOTEXISTENCE"); %>
                                <% FwGetHwOptionRemark("18","3","BEGIN","NOTEXISTENCE"); %>
                                <a id="tab0" href='javascript:void(0);' class=menu onclick="ChgTab(0);">Primary</a> &nbsp;<b>|</b>&nbsp;
                                <a id="tab1" href='javascript:void(0);' class=menu onclick="ChgTab(1);">Secondary</a> &nbsp;<b>|</b>&nbsp;
                                <a id="tab2" href='javascript:void(0);' class=menu onclick="ChgTab(2);">Tertiary</a> &nbsp;<b>|</b>&nbsp;
                                <a id="tab3" href='javascript:void(0);' class=menu onclick="ChgTab(3);">Quaternary</a> &nbsp;
                                <% FwGetHwOptionRemark("18","3","END","NOTEXISTENCE"); %>
                            </td>
                        </tr>
                        <tr>
                            <td class=td_NormalLeft>&nbsp;Camera Name</td>
                            <td class=td_NormalRight>&nbsp; <input type=text name=CamName size=32 maxlength=21 class=obj_Normal></td>
                        </tr>
                        <tr>
                            <td class=td_NormalLeft>&nbsp;Frame Rate</td>
                            <td class=td_NormalRight>
                                <div id=FR_Str></div>
                            </td>
                        </tr>
                        <script language="JavaScript">
                            switch(PORTID)
                            {
                                case 0:
                                    document.write("<tr>" +
                                                        "<td class=td_NormalLeft>&nbsp;Image Size</td>" +
                                                        "<td class=td_NormalRight>&nbsp; " +
                                                            <% FwGetHwOptionRemark("40","0","C_BEGIN","NOTEXISTENCE"); %>
                                                            "<select name=ImgSize>" +
                                                            <% FwGetHwOptionRemark("40","0","C_END","NOTEXISTENCE"); %>
                                                            <% FwGetHwOptionRemark("40","0","C_BEGIN","EXISTENCE"); %>
                                                            "<select name=ImgSize disabled>" +
                                                            <% FwGetHwOptionRemark("40","0","C_END","EXISTENCE"); %>
                                                                "<option value=6>1280 x 720" +
                                                                "<option value=7>1280 x 1024" +
                                                                "<option value=9>1920 x 1080 &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +
                                                            "</select>" +
                                                        "</td>" +
                                                    "</tr>");
                                    break;
                                case 1:
                                    document.write("<tr>" +
                                                        "<td class=td_NormalLeft>&nbsp;Image Size</td>" +
                                                        "<td class=td_NormalRight>&nbsp; " +
                                                            "<select name=ImgSize>" +
                                                                "<option value=1>320 x 240" +
                                                                "<option value=2>640 x 352" +
                                                                "<option value=3>640 x 480" +
                                                                "<option value=4>704 x 480" +
                                                                "<option value=5>720 x 480" +
                                                                "<option value=6>1280 x 720 &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +
                                                            "</select>" +
                                                        "</td>" +
                                                    "</tr>");
                                    break;
                                case 2:
                                    document.write("<tr>" +
                                                        "<td class=td_NormalLeft>&nbsp;Image Size</td>" +
                                                        "<td class=td_NormalRight>&nbsp; " +
                                                            "<select name=ImgSize>" +
                                                                "<option value=1>320 x 240 &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +
                                                            "</select>" +
                                                        "</td>" +
                                                    "</tr>");
                                    break;
                                case 3:
/*
                                    var StrImg;
                                    var StrSize1 = "<option value=1>320 x 240";
                                    var StrSize2 = "<option value=2>640 x 352";
                                    var StrSize3 = "<option value=3>640 x 480";
                                    var StrSize4 = "<option value=4>704 x 480";
                                    var StrSize5 = "<option value=5>720 x 480";
                                    var StrSize6 = "<option value=6>1280 x 720";
                                    var StrSize7 = "<option value=7>1280 x 1024";
                                    var StrSize9 = "<option value=9>1920 x 1080";
                                    var StrSize12 = "<option value=12>2304 x 1728";
                                    var StrSize14 = "<option value=14>2592 x 1944";

                                    var ImgArr = [];
                                    var ImgUArr = [];
                                    for (idx = 0; idx < 3; idx++)
                                        ImgArr[idx] = eval("IMGSIZE" + idx);
                                    ImgArr.sort(function(a, b) {
                                    return a - b;
                                    });
                                    for (var idx = 0; idx < ImgArr.length; idx++)
                                        if (ImgUArr.indexOf(ImgArr[idx]) === -1) ImgUArr.push(ImgArr[idx]);
                                    for (var idx = 0; idx < ImgUArr.length; idx++)
                                        StrImg += eval("StrSize" + ImgUArr[idx]);                                   
*/
                                    var StrImg;
                                    var StrPort0 = "<option value=0>Pri:";
                                    var StrPort1 = "<option value=1>Sec:";
                                    var StrPort2 = "<option value=2>Ter:";
                                    var StrSize1 = "320 x 240";
                                    var StrSize2 = "640 x 352";
                                    var StrSize3 = "640 x 480";
                                    var StrSize4 = "704 x 480";
                                    var StrSize5 = "720 x 480";
                                    var StrSize6 = "1280 x 720";
                                    var StrSize7 = "1280 x 1024";
                                    var StrSize9 = "1920 x 1080";
                                    var StrSize12 = "2304 x 1728";
                                    var StrSize14 = "2592 x 1944";

                                    StrImg = StrPort0 + eval("StrSize" + IMGSIZE0) + StrPort1 + eval("StrSize" + IMGSIZE1) + StrPort2 + eval("StrSize" + IMGSIZE2);

                                    document.write("<tr>" +
                                                        "<td class=td_NormalLeft>&nbsp;Image Size</td>" +
                                                        "<td class=td_NormalRight>&nbsp; " +
                                                            "<select name=ImgSize>");
                                    document.write(StrImg);
                                    document.write(         "</select>" +
                                                        "</td>" +
                                                    "</tr>");
                                    break;
                            }
                        </script>
                        <script language="JavaScript">
                            switch(PORTID)
                            {
                                case 3:
                                    document.write("<tr>" +
                                                        "<td class=td_NormalLeft>&nbsp;Encoding Standard</td>" +
                                                        "<td class=td_NormalRight>&nbsp; " +
                                                            "<select name=CodecType onchange='ChgCodecType();''>" +
                                                                "<option value=0>M-JPEG" +
                                                            "</select>" +
                                                        "</td>" +
                                                    "</tr>");
                                    break;
                                default :
                                    document.write("<tr>" +
                                                        "<td class=td_NormalLeft>&nbsp;Encoding Standard</td>" +
                                                        "<td class=td_NormalRight>&nbsp; " +
                                                            "<select name=CodecType onchange='ChgCodecType();''>" +
                                                                "<option value=2>H.264" +
                                                                "<option value=3>H.265" +
                                                            "</select>" +
                                                        "</td>" +
                                                    "</tr>");
                                    break;
                            }
                        </script>
                        <tbody id=Stream_Str></tbody>
                        <% FwGetHwOptionRemark("28","0","BEGIN","EXISTENCE"); %>
                        <tr>
                            <td class=td_NormalLeft>&nbsp;Audio</td>
                            <td class=td_NormalRight>&nbsp;
                                <input type=radio name=AudioInstalled value=1> Enable &nbsp;
                                <input type=radio name=AudioInstalled value=0> Disable
                            </td>
                        </tr>
                        <% FwGetHwOptionRemark("28","0","END","EXISTENCE"); %>
                        <% FwGetHwOptionRemark("28","0","BEGIN","NOTEXISTENCE"); %>
                        <tr>
                            <td class=td_NormalLeft>&nbsp;Audio</td>
                            <td class=td_NormalRight>
                                <input type=radio name=AudioInstalled value=1 disabled> Enable &nbsp;
                                <input type=radio name=AudioInstalled value=0 disabled> Disable
                            </td>
                        </tr>
                        <% FwGetHwOptionRemark("28","0","END","NOTEXISTENCE"); %>
                        <tr>
                            <td colspan=2 align=center height=40>
                                <input type=hidden name="FwModId">
                                <input type=hidden name="PortId">
                                <input type=hidden name='FwCgiVer' value='0x0001'>
                                <input type=hidden name='FwMkChg' value='YES'>
                                <input type=hidden name='RetPage' value='/admin/ret_ok.asp'>
                                <input type=button class=obj_Button name=tovideoport value=" Apply " onclick="VideoPortSubmit();">
                            </td>
                        </tr>
                    </table>
                </form>
            </td>
        </tr>
    </table>
</body>
</html>
