<html>
<head>
    <% FwIncludeFile("/web/charset.txt"); %>
    <meta http-equiv="expires" content="0">
    <meta http-equiv="pragma" content="no-cache">
    <link rel="stylesheet" href="/style.css" type="text/css">
    <script src="/js/jquery-3.6.0.min.js" type="text/javascript"></script>
    <script language="JavaScript">
    FWMODID = 0;
    PORTID = 0;
    MAXCHANNEL = 3;
    <% FwVideoModeGet("FwModId"); %>
    <% FwGetDiDoState("FwModId"); %>
    <% FwGetPtzModConf("FwModId"); %>
    <% NssDefAppPorts(); %>
    <% NetDefEth0Cfg(); %>

    var IP = document.location.hostname;
    var PresetName;
    var CHANNEL_STATUS = 0;
    var gwidth;
    var gheight;
    var gViewUrl = new Array(MAXCHANNEL);

    function GetData() {
        with (document.all) {
            GetChannel();

            var iFrm0 = $('<iframe id="iFrm0" style="width:100%; height:100%" scrolling="no"></iframe>');
            $("#ViewerArea0").append(iFrm0);
            var iFrm1 = $('<iframe id="iFrm1" style="width:100%; height:100%" scrolling="no"></iframe>');
            $("#ViewerArea1").append(iFrm1);
            var iFrm2 = $('<iframe id="iFrm2" style="width:100%; height:100%" scrolling="no"></iframe>');
            $("#ViewerArea2").append(iFrm2);
            var iFrm3 = $('<iframe id="iFrm3" style="width:100%; height:100%" scrolling="no"></iframe>');
            $("#ViewerArea3").append(iFrm3);

            $("#ViewerBox").css('display', 'flex');
            $("#ViewerBox").css('flex-wrap', 'wrap');

            $("#ViewerArea0").css("flex", "100%");
            $("#ViewerArea0").css("height", "100%");
            $("#ViewerArea0").css("display", "");
            $('#iFrm0').attr('src', "");
        }
    }

    function GetChannel() {
        with (document.all) {
            statchannel0.checked = ( (CHANNEL_STATUS & 0x01 << 0) ? true : false );
            statchannel1.checked = ( (CHANNEL_STATUS & 0x01 << 1) ? true : false );
            statchannel2.checked = ( (CHANNEL_STATUS & 0x01 << 2) ? true : false );
            statchannel3.checked = ( (CHANNEL_STATUS & 0x01 << 3) ? true : false );
        }
    }

    function ChgChannel( ChannelIndex ) {
        with (document.all) {
            if ( ChannelIndex != "none")
            {
                if( eval("statchannel" + ChannelIndex).checked )
                {
                    eval("statchannel" + ChannelIndex).checked = false;
                }
                else
                {
                    eval("statchannel" + ChannelIndex).checked = true;
                }
            }

            CHANNEL_STATUS =  (statchannel0.checked << 0) | (statchannel1.checked << 1) | (statchannel2.checked << 2) | (statchannel3.checked << 3);

            switch (CHANNEL_STATUS)
            {
                case 0:
                    $("#ViewerArea0").css("flex", "100%");
                    $("#ViewerArea0").css("height", "100%");
                    $("#ViewerArea0").css("display", "none");
                    $("#ViewerArea1").css("flex", "");
                    $("#ViewerArea1").css("height", "0");
                    $("#ViewerArea1").css("display", "none");
                    $("#ViewerArea2").css("flex", "");
                    $("#ViewerArea2").css("height", "0");
                    $("#ViewerArea2").css("display", "none");
                    $("#ViewerArea3").css("flex", "");
                    $("#ViewerArea3").css("height", "0");
                    $("#ViewerArea3").css("display", "none");

                    $('#iFrm0').attr('src', "");
                    $('#iFrm1').attr('src', "");
                    $('#iFrm2').attr('src', "");
                    $('#iFrm3').attr('src', "");
                    break;
                case 1:
                case 2:
                case 4:
                case 8:
                    $("#ViewerArea0").css("flex", "100%");
                    $("#ViewerArea0").css("height", "100%");
                    $("#ViewerArea1").css("flex", "");
                    $("#ViewerArea1").css("height", "0");
                    $("#ViewerArea2").css("flex", "");
                    $("#ViewerArea2").css("height", "0");
                    $("#ViewerArea3").css("flex", "");
                    $("#ViewerArea3").css("height", "0");

                    $("#ViewerArea0").css("display", "");
                    $("#ViewerArea1").css("display", "none");
                    $("#ViewerArea2").css("display", "none");
                    $("#ViewerArea3").css("display", "none");

                    $('#iFrm0').attr('src', "");
                    $('#iFrm1').attr('src', "");
                    $('#iFrm2').attr('src', "");
                    $('#iFrm3').attr('src', "");
                    break;

                case 3:
                case 5:
                case 6:
                case 9:
                case 10:
                case 12:
                    $("#ViewerArea0").css("flex", "0 50%");
                    $("#ViewerArea0").css("height", "100%");
                    $("#ViewerArea1").css("flex", "0 50%");
                    $("#ViewerArea1").css("height", "100%");
                    $("#ViewerArea2").css("flex", "");
                    $("#ViewerArea2").css("height", "0");
                    $("#ViewerArea3").css("flex", "");
                    $("#ViewerArea3").css("height", "0");

                    $("#ViewerArea0").css("display", "");
                    $("#ViewerArea1").css("display", "");
                    $("#ViewerArea2").css("display", "none");
                    $("#ViewerArea3").css("display", "none");

                    $('#iFrm0').attr('src', "");
                    $('#iFrm1').attr('src', "");
                    $('#iFrm2').attr('src', "");
                    $('#iFrm3').attr('src', "");
                    break;

                case 7:
                case 11:
                case 13:
                case 14:
                    $("#ViewerArea0").css("flex", "0 50%");
                    $("#ViewerArea0").css("height", "50%");
                    $("#ViewerArea1").css("flex", "0 50%");
                    $("#ViewerArea1").css("height", "50%");
                    $("#ViewerArea2").css("flex", "0 50%");
                    $("#ViewerArea2").css("height", "50%");
                    $("#ViewerArea3").css("flex", "0 50%");
                    $("#ViewerArea3").css("height", "50%");

                    $("#ViewerArea0").css("display", "");
                    $("#ViewerArea1").css("display", "");
                    $("#ViewerArea2").css("display", "");
                    $("#ViewerArea3").css("display", "");

                    $('#iFrm0').attr('src', "");
                    $('#iFrm1').attr('src', "");
                    $('#iFrm2').attr('src', "");
                    $('#iFrm3').attr('src', "");
                    break;

                case 15:
                    $("#ViewerArea0").css("flex", "0 50%");
                    $("#ViewerArea0").css("height", "50%");
                    $("#ViewerArea1").css("flex", "0 50%");
                    $("#ViewerArea1").css("height", "50%");
                    $("#ViewerArea2").css("flex", "0 50%");
                    $("#ViewerArea2").css("height", "50%");
                    $("#ViewerArea3").css("flex", "0 50%");
                    $("#ViewerArea3").css("height", "50%");

                    $("#ViewerArea0").css("display", "");
                    $("#ViewerArea1").css("display", "");
                    $("#ViewerArea2").css("display", "");
                    $("#ViewerArea3").css("display", "");

                    $('#iFrm0').attr('src', "");
                    $('#iFrm1').attr('src', "");
                    $('#iFrm2').attr('src', "");
                    $('#iFrm3').attr('src', "");
                    break;
            }

            ChgStart();
        }
    }

    function ViewerResize() {
        with (document.all) {
            if ( ViewerViewType[0].checked == true )
                return;

            gwidth = $('#ViewerArea0').width();
            gheight = $('#ViewerArea0').height();

            switch (CHANNEL_STATUS)
            {
                case 0:
                    break;
                case 1:
                case 2:
                case 4:
                case 8:
                    $('#iFrm0').contents().find("#id_image").width(gwidth);
                    $('#iFrm0').contents().find("#id_image").height(gheight);
                    if( String($('#iFrm0').attr('src') ).indexOf("h264") > -1 )
                    {
/*
                        $('#iFrm0').contents().find("#id_image").css("top","0");
                        $('#iFrm0').contents().find("#id_image").css("left","0");
                        $('#iFrm0').contents().find("#id_image").css("bottom","0");
                        $('#iFrm0').contents().find("#id_image").css("right","0");
                        $('#iFrm0').contents().find("#id_image").css("z-index","-1000");
                        $('#iFrm0').contents().find("#id_image").css("width","100%");
                        $('#iFrm0').contents().find("#id_image").css("height","100%");
*/
                    }
                    break;

                case 3:
                case 5:
                case 6:
                case 9:
                case 10:
                case 12:
                    $('#iFrm0').contents().find("#id_image").width(gwidth);
                    $('#iFrm0').contents().find("#id_image").height(gheight);
                    $('#iFrm1').contents().find("#id_image").width(gwidth);
                    $('#iFrm1').contents().find("#id_image").height(gheight);
                    break;

                case 7:
                case 11:
                case 13:
                case 14:
                    $('#iFrm0').contents().find("#id_image").width(gwidth);
                    $('#iFrm0').contents().find("#id_image").height(gheight);
                    $('#iFrm1').contents().find("#id_image").width(gwidth);
                    $('#iFrm1').contents().find("#id_image").height(gheight);
                    $('#iFrm2').contents().find("#id_image").width(gwidth);
                    $('#iFrm2').contents().find("#id_image").height(gheight);
                    break;

                case 15:
                    $('#iFrm0').contents().find("#id_image").width(gwidth);
                    $('#iFrm0').contents().find("#id_image").height(gheight);
                    $('#iFrm1').contents().find("#id_image").width(gwidth);
                    $('#iFrm1').contents().find("#id_image").height(gheight);
                    $('#iFrm2').contents().find("#id_image").width(gwidth);
                    $('#iFrm2').contents().find("#id_image").height(gheight);
                    $('#iFrm3').contents().find("#id_image").width(gwidth);
                    $('#iFrm3').contents().find("#id_image").height(gheight);
                    break;
            }
        }
    }

    function ChgStart() {
        with (document.all) {
            var idx;
            for (idx = 0; idx < MAXCHANNEL; idx++)
            {
                if ( eval("CODECTYPE" + idx ) == 0)
                {
                    gViewUrl[idx] = "./websocket_jpg.asp?PortId=" + idx;
                }
                else if ( eval("CODECTYPE" + idx ) == 2)
                {
                    gViewUrl[idx] = "./websocket_h264.asp?PortId=" + idx;
                }
                else if ( eval("CODECTYPE" + idx ) == 3)
                {
                    gViewUrl[idx] = "./websocket_h265.asp?PortId=" + idx;
                }
            }
            
            switch (CHANNEL_STATUS)
            {
                case 0:
                    $('#iFrm0').attr('src', "");
                    $('#iFrm1').attr('src', "");
                    $('#iFrm2').attr('src', "");
                    $('#iFrm3').attr('src', "");
                    break;
                case 1:
                case 2:
                case 4:
                case 8:
                    if (CHANNEL_STATUS & (0x01 << 0))
                        $('#iFrm0').attr('src', gViewUrl[0]);
                    else if (CHANNEL_STATUS & (0x01 << 1))
                        $('#iFrm0').attr('src', gViewUrl[1]);
                    else if (CHANNEL_STATUS & (0x01 << 2))
                        $('#iFrm0').attr('src', gViewUrl[2]);
                    else if (CHANNEL_STATUS & (0x01 << 3))
                        $('#iFrm0').attr('src', "");
                    
                    $('#iFrm1').attr('src', "");
                    $('#iFrm2').attr('src', "");
                    $('#iFrm3').attr('src', "");
                    break;

                case 3:
                case 5:
                case 6:
                case 9:
                case 10:
                case 12:
                    if ( (CHANNEL_STATUS & (0x01 << 0)) && (CHANNEL_STATUS & (0x01 << 1)) )
                    {
                        $('#iFrm0').attr('src', gViewUrl[0]);
                        $('#iFrm1').attr('src', gViewUrl[1]);
                    }
                    else if ( (CHANNEL_STATUS & (0x01 << 0)) && (CHANNEL_STATUS & (0x01 << 2)) )
                    {
                        $('#iFrm0').attr('src', gViewUrl[0]);
                        $('#iFrm1').attr('src', gViewUrl[2]);
                    }
                    else if ( (CHANNEL_STATUS & (0x01 << 1)) && (CHANNEL_STATUS & (0x01 << 2)) )
                    {
                        $('#iFrm0').attr('src', gViewUrl[1]);
                        $('#iFrm1').attr('src', gViewUrl[2]);
                    }
                    else if ( (CHANNEL_STATUS & (0x01 << 0)) && (CHANNEL_STATUS & (0x01 << 3)) )
                    {
                        $('#iFrm0').attr('src', gViewUrl[0]);
                        $('#iFrm1').attr('src', "");
                    }
                    else if ( (CHANNEL_STATUS & (0x01 << 1)) && (CHANNEL_STATUS & (0x01 << 3)) )
                    {
                        $('#iFrm0').attr('src', gViewUrl[1]);
                        $('#iFrm1').attr('src', "");
                    }
                    else if ( (CHANNEL_STATUS & (0x01 << 2)) && (CHANNEL_STATUS & (0x01 << 3)) )
                    {
                        $('#iFrm0').attr('src', gViewUrl[2]);
                        $('#iFrm1').attr('src', "");
                    }

                    $('#iFrm2').attr('src', "");
                    $('#iFrm3').attr('src', "");
                    break;

                case 7:
                case 11:
                case 13:
                case 14:
                    if ( (CHANNEL_STATUS & (0x01 << 0)) && (CHANNEL_STATUS & (0x01 << 1)) && (CHANNEL_STATUS & (0x01 << 2)) )
                    {
                        $('#iFrm0').attr('src', gViewUrl[0]);
                        $('#iFrm1').attr('src', gViewUrl[1]);
                        $('#iFrm2').attr('src', gViewUrl[2]);
                    }
                    else if ( (CHANNEL_STATUS & (0x01 << 0)) && (CHANNEL_STATUS & (0x01 << 1)) && (CHANNEL_STATUS & (0x01 << 3)) )
                    {
                        $('#iFrm0').attr('src', gViewUrl[0]);
                        $('#iFrm1').attr('src', gViewUrl[1]);
                        $('#iFrm2').attr('src', "");
                    }
                    else if ( (CHANNEL_STATUS & (0x01 << 0)) && (CHANNEL_STATUS & (0x01 << 2)) && (CHANNEL_STATUS & (0x01 << 3)) )
                    {
                        $('#iFrm0').attr('src', gViewUrl[0]);
                        $('#iFrm1').attr('src', gViewUrl[2]);
                        $('#iFrm2').attr('src', "");
                    }
                    else if ( (CHANNEL_STATUS & (0x01 << 1)) && (CHANNEL_STATUS & (0x01 << 2)) && (CHANNEL_STATUS & (0x01 << 3)) )
                    {
                        $('#iFrm0').attr('src', gViewUrl[1]);
                        $('#iFrm1').attr('src', gViewUrl[2]);
                        $('#iFrm2').attr('src', "");
                    }

                    $('#iFrm3').attr('src', "");
                    break;

                case 15:
                    $('#iFrm0').attr('src', gViewUrl[0]);
                    $('#iFrm1').attr('src', gViewUrl[1]);
                    $('#iFrm2').attr('src', gViewUrl[2]);
                    $('#iFrm3').attr('src', "");
                    break;
            }

            setTimeout(function() {
                ViewerResize();
            }, 100);
        }
    }

    function ChgStop() {
        with (document.all) {
            $('#iFrm0').attr('src', "");
            $('#iFrm1').attr('src', "");
            $('#iFrm2').attr('src', "");
            $('#iFrm3').attr('src', "");
        }
    }

    $(window).resize( function () {
        ViewerResize();
    });

    function Ptz() {
        if (!(PTZINSTFLAG & 0x01)) {
            alert("PTZ device is not installed.");
            return;
        }

        document.all.id_div_ptz.style.display = "";

        var PRESETNAME_StartPos = new Array(255);
        var PRESETNAME_StrCnt = new Array(255);
        var PRESETNAME = new Array(31);
        var PRESETENPAGE = new Array(7);

        for (var i = 0; i < 8; i++) {
            var StartStr = "PRESETENPAGE" + i + "=";
            PRESETENPAGE[i] = PresetName.substring(PresetName.indexOf(StartStr) + 14, PresetName.indexOf(StartStr) + 24);
        }

        for (var i = 0; i < 256; i++) {
            var j = i + 1;
            var StartStr = "PRESETNAME" + i + "=\"";
            var EndStr = "PRESETNAME" + j + "=\"";
            if (i == 255)
                EndStr = "PRESETENPAGE7";

            PRESETNAME_StartPos[i] = PresetName.indexOf(StartStr);

            if (i < 10) {
                PRESETNAME_StrCnt[i] = parseInt((PresetName.indexOf(EndStr) - 3) - (PRESETNAME_StartPos[i] + 13), 10);
                PRESETNAME[i] = PresetName.substr(PRESETNAME_StartPos[i] + 13, PRESETNAME_StrCnt[i]);
            }
            else if (i < 100) {
                PRESETNAME_StrCnt[i] = parseInt((PresetName.indexOf(EndStr) - 3) - (PRESETNAME_StartPos[i] + 14), 10);
                PRESETNAME[i] = PresetName.substr(PRESETNAME_StartPos[i] + 14, PRESETNAME_StrCnt[i]);
            }
            else {
                PRESETNAME_StrCnt[i] = parseInt((PresetName.indexOf(EndStr) - 3) - (PRESETNAME_StartPos[i] + 15), 10);
                PRESETNAME[i] = PresetName.substr(PRESETNAME_StartPos[i] + 15, PRESETNAME_StrCnt[i]);
            }

            if (PRESETNAME[i].indexOf("\";") != -1) {
                var CurrentPreset = PRESETNAME[i].split("\";");
                PRESETNAME[i] = CurrentPreset[0];
            }
        }

        parseInt(document.all.PORTID, 10) + 1;
        var optionStr = "<select name=SetCall style='width:143px;' onChange='PtzCall();'>";

        for (i = 0; i < 256; i++) {
            var lSftValue = i % 32;

            if (i >= 0 && i <= 31) {
                if (PRESETENPAGE[0] & (0x01 << parseInt(lSftValue)))
                    optionStr += "<option value=" + i + "> " + PRESETNAME[i];
            }
            else if (i >= 32 && i <= 63) {
                if (PRESETENPAGE[1] & (0x01 << parseInt(lSftValue)))
                    optionStr += "<option value=" + i + "> " + PRESETNAME[i];
            }
            else if (i >= 64 && i <= 95) {
                if (PRESETENPAGE[2] & (0x01 << parseInt(lSftValue)))
                    optionStr += "<option value=" + i + "> " + PRESETNAME[i];
            }
            else if (i >= 96 && i <= 127) {
                if (PRESETENPAGE[3] & (0x01 << parseInt(lSftValue)))
                    optionStr += "<option value=" + i + "> " + PRESETNAME[i];
            }
            else if (i >= 128 && i <= 159) {
                if (PRESETENPAGE[4] & (0x01 << parseInt(lSftValue)))
                    optionStr += "<option value=" + i + "> " + PRESETNAME[i];
            }
            else if (i >= 160 && i <= 191) {
                if (PRESETENPAGE[5] & (0x01 << parseInt(lSftValue)))
                    optionStr += "<option value=" + i + "> " + PRESETNAME[i];
            }
            else if (i >= 192 && i <= 223) {
                if (PRESETENPAGE[6] & (0x01 << parseInt(lSftValue)))
                    optionStr += "<option value=" + i + "> " + PRESETNAME[i];
            }
            else if (i >= 224 && i <= 255) {
                if (PRESETENPAGE[7] & (0x01 << parseInt(lSftValue)))
                    optionStr += "<option value=" + i + "> " + PRESETNAME[i];
            }
        }
        optionStr += "</select>"

        document.getElementById("optStr").innerHTML = optionStr;
    }

    function PtzCmdCtlMode(ContCmdCode, StepCmdCode) {
        with (document.all) {
            if (ptzMode.value == "1") {
                location.href = "/goform/app/FwPtzCtr?FwModId=" + ModSelect.value + "&PortId=" + PORTID + "&PtzCode=" + ContCmdCode + "&PtzParm=" + ptzSpeed.value + "&FwCgiVer=0x0001";
            }
            else {
                location.href = "/goform/app/FwPtzCtr?FwModId=" + ModSelect.value + "&PortId=" + PORTID + "&PtzCode=" + StepCmdCode + "&PtzParm=" + ptzSpeed.value + "&FwCgiVer=0x0001";
            }
        }
    }

    function PtzCmdCtl(CmdCode) {
        with (document.all) {
            if (ptzMode.value == "1") {
                location.href = "/goform/app/FwPtzCtr?FwModId=" + ModSelect.value + "&PortId=" + PORTID + "&PtzCode=" + CmdCode + "&PtzParm=" + ptzSpeed.value + "&FwCgiVer=0x0001";
            }
        }
    }

    function PtzOptCmdCtl(CmdCode) {
        with (document.all) {
            location.href = "/goform/app/FwPtzCtr?FwModId=" + ModSelect.value + "&PortId=" + PORTID + "&PtzCode=" + CmdCode + "&PtzParm=" + ptzIndex.value + "&FwCgiVer=0x0001";
        }

    }

    function PtzCall() {
        with (document.all) {
            location.href = "/cgi-bin/fwptzctr.cgi?FwModId=" + ModSelect.value + "&PortId=" + PORTID + "&PtzCode=0x112&PtzParm=" + SetCall.value + "&FwCgiVer=0x0001";
        }
    }

    function SH_Ptz()
    {
        if (document.all.id_div_ptz.style.display == "none")
        {
            Ptz();
        }
        else
        {
            document.all.id_div_ptz.style.display = "none"
        }
    }

    function PtzClose()
    {
        document.all.id_div_ptz.style.display = "none";
    }
    </script>
</head>

<body leftmargin="0" topmargin="0" marginwidth="0" marginheight="0" onload="GetData();">
<table width="100%" height="100%" border="0" cellpadding="0" cellspacing="0" class="topLine">
    <tr>
        <td width="200" valign="top" bgcolor="#D7E6F0" class="rightLine">
            <div id="id_div_ch">
                <table width="220" border="0" cellspacing="0" cellpadding="0">
                    <tr>
                        <td colspan=4>&nbsp;</td>
                    </tr>
                    <tr>
                        <td>Ch 1<input type=checkbox name=statchannel0 disabled></td>
                        <td>Ch 2<input type=checkbox name=statchannel1 disabled></td>
                        <td>Ch 3<input type=checkbox name=statchannel2 disabled></td>
                        <td>Ch 4<input type=checkbox name=statchannel3 disabled></td>
                    </tr>
                    <tr>
                        <td colspan=4>&nbsp;</td>
                    </tr>
                    <tr>
                        <td colspan=4>
                            <input type=radio name=ViewerViewType onclick="ChgChannel('none');" checked>Origin Size&nbsp;
                            <input type=radio name=ViewerViewType onclick="ChgChannel('none');">Fit Window
                        </td>
                    </tr>
                    <tr>
                        <td colspan=4>&nbsp;</td>
                    </tr>
                    <tr>
                        <td colspan=4>
                            <input type=button name=tochannel0 value=" Channel 1 " onclick="ChgChannel('0');" class=obj_Button>
                            <input type=button name=tochannel1 value=" Channel 2 " onclick="ChgChannel('1');" class=obj_Button><br>
                            <input type=button name=tochannel2 value=" Channel 3 " onclick="ChgChannel('2');" class=obj_Button>
                            <input type=button name=tochannel3 value=" Channel 4 " onclick="ChgChannel('3');" class=obj_Button><br><br>
                            <input type=button name=torefresh value=" Refresh " onClick="location.reload();" class=obj_Button>
                        </td>
                    </tr>
                </table>
            </div>
        </td>
        <td valign="top" bgcolor="#C8DAE8" class="rightLine">
            <div id="id_div_ptz">
                <table width="190" border="0" cellpadding="0" cellspacing="0" bgcolor="#C8DAE8">
                    <tr>
                        <td>
                            <table width="190" border="0" cellspacing="0" cellpadding="0">
                                <tr>
                                    <td width="185" align="center" bgcolor="#98AFCC" class="adm">
                                        <font color=#ffffff><b>Pan / Tilt / Zoom</b></font>
                                    </td>
                                    <td width="15"><a href="javascript:PtzClose();" onMouseOver="document.all.Img3.src='/img/closeOver.gif'" onMouseOut="document.all.Img3.src='/img/close.gif'"><img src="/img/close.gif" width="15" height="15" id="Img3" border="0"></a></td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                    <tr>
                        <td valign="top" height="10"></td>
                    </tr>
                    <tr>
                        <td align="center" valign="middle">Speed&nbsp;
                            <select name=ptzSpeed style='width:70px;'>
                                <option value=1> 1
                                <option value=2> 2
                                <option value=3> 3
                                <option value=4> 4
                                <option value=5> 5
                                <option value=6> 6
                                <option value=7> 7
                                <option value=8> 8
                                <option value=9> 9
                                <option value=10 selected> 10
                                <option value=11> 11
                                <option value=12> 12
                                <option value=13> 13
                                <option value=14> 14
                                <option value=15> 15
                                <option value=16> 16
                            </select>
                        </td>
                    </tr>
                    <tr>
                        <td valign="top" height="10"></td>
                    </tr>
                    <tr>
                        <td align="center">
                            <table width="138" border="0" cellspacing="0" cellpadding="0">
                                <tr>
                                    <td><img src="/img/ptz/up_left.gif" width="56" height="56" border="0" title=" Left Up " onMouseDown="PtzCmdCtlMode('0x106','0x306');" onMouseUp="PtzCmdCtl('0x206');" onMouseOver="this.src='/img/ptz/up_leftOver.gif'" onMouseOut="this.src='/img/ptz/up_left.gif'"></td>
                                    <td><img src="/img/ptz/up.gif" width="56" height="56" border="0" title=" Up " onMouseDown="PtzCmdCtlMode('0x107','0x307');" onMouseUp="PtzCmdCtl('0x207');" onMouseOver="this.src='/img/ptz/upOver.gif'" onMouseOut="this.src='/img/ptz/up.gif'"></td>
                                    <td><img src="/img/ptz/up_right.gif" width="56" height="56" border="0" title=" Right Up " onMouseDown="PtzCmdCtlMode('0x108','0x308');" onMouseUp="PtzCmdCtl('0x208');" onMouseOver="this.src='/img/ptz/up_rightOver.gif'" onMouseOut="this.src='/img/ptz/up_right.gif'"></td>
                                </tr>
                                <tr>
                                    <td><img src="/img/ptz/left.gif" width="56" height="56" border="0" title=" Left " onMouseDown="PtzCmdCtlMode('0x103','0x303');" onMouseUp="PtzCmdCtl('0x203');" onMouseOver="this.src='/img/ptz/leftOver.gif'" onMouseOut="this.src='/img/ptz/left.gif'"></td>
                                    <td><img src="/img/ptz/home.gif" width="56" height="56" border="0" title="Home" onMouseDown="PtzCmdCtlMode('0x104','0x304');" onMouseOver="this.src='/img/ptz/homeOver.gif'" onMouseOut="this.src='/img/ptz/home.gif'"></td>
                                    <td><img src="/img/ptz/right.gif" width="56" height="56" border="0" title=" Right " onMouseDown="PtzCmdCtlMode('0x105','0x305');" onMouseUp="PtzCmdCtl('0x205');" onMouseOver="this.src='/img/ptz/rightOver.gif'" onMouseOut="this.src='/img/ptz/right.gif'"></td>
                                </tr>
                                <tr>
                                    <td><img src="/img/ptz/down_left.gif" width="56" height="56" border="0" title=" Left Down " onMouseDown="PtzCmdCtlMode('0x100','0x300');" onMouseUp="PtzCmdCtl('0x200');" onMouseOver="this.src='/img/ptz/down_leftOver.gif'" onMouseOut="this.src='/img/ptz/down_left.gif'"></td>
                                    <td><img src="/img/ptz/down.gif" width="56" height="56" border="0" title=" Down " onMouseDown="PtzCmdCtlMode('0x101','0x301');" onMouseUp="PtzCmdCtl('0x201');" onMouseOver="this.src='/img/ptz/downOver.gif'" onMouseOut="this.src='/img/ptz/down.gif'"></td>
                                    <td><img src="/img/ptz/down_right.gif" width="56" height="56" border="0" title=" Right Down " onMouseDown="PtzCmdCtlMode('0x102','0x302');" onMouseUp="PtzCmdCtl('0x202');" onMouseOver="this.src='/img/ptz/down_rightOver.gif'" onMouseOut="this.src='/img/ptz/down_right.gif'"></td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                    <tr>
                        <td valign="top" height="10"></td>
                    </tr>
                    <tr>
                        <td align="center">
                            <table width="160" border="0" align="center" cellpadding="1" cellspacing="2">
                                <tr align="center">
                                    <td><a onMouseDown="PtzCmdCtlMode('0x10B','0x30B');" onMouseUp="PtzCmdCtl('0x20B');"><img src="/img/ptz/zoom_in.gif" title=" Zoom In " border=0 onMouseOver="this.src='/img/ptz/zoom_inOver.gif'" onMouseOut="this.src='/img/ptz/zoom_in.gif'"></a></td>
                                    <td><a onMouseDown="PtzCmdCtlMode('0x10C','0x30C');" onMouseUp="PtzCmdCtl('0x20C');"><img src="/img/ptz/zoom_out.gif" title=" Zoom Out " border=0 onMouseOver="this.src='/img/ptz/zoom_outOver.gif'" onMouseOut="this.src='/img/ptz/zoom_out.gif'"></a></td>
                                </tr>
                                <tr align="center">
                                    <td><a onMouseDown="PtzCmdCtlMode('0x10D','0x30D');" onMouseUp="PtzCmdCtl('0x20D');"><img src="/img/ptz/focus_far.gif" title=" Focus Far " border=0 onMouseOver="this.src='/img/ptz/focus_farOver.gif'" onMouseOut="this.src='/img/ptz/focus_far.gif'"></a></td>
                                    <td><a onMouseDown="PtzCmdCtlMode('0x10E','0x30E');" onMouseUp="PtzCmdCtl('0x20E');"><img src="/img/ptz/focus_near.gif" title=" Focus Near " border=0 onMouseOver="this.src='/img/ptz/focus_nearOver.gif'" onMouseOut="this.src='/img/ptz/focus_near.gif'"></a></td>
                                </tr>
                                <tr align="center">
                                    <td><a href="javascript:PtzCmdCtlMode('0x109','0x309');"><img src="/img/ptz/auto_start.gif" title=" Auto Pan Start " border=0 onMouseOver="this.src='/img/ptz/auto_startOver.gif'" onMouseOut="this.src='/img/ptz/auto_start.gif'"></a></td>
                                    <td><a href="javascript:PtzCmdCtlMode('0x10A','0x30A');"><img src="/img/ptz/auto_stop.gif" title=" Auto Pan Stop " border=0 onMouseOver="this.src='/img/ptz/auto_stopOver.gif'" onMouseOut="this.src='/img/ptz/auto_stop.gif'"></a></td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                    <tr>
                        <td valign="top" height="10"></td>
                    </tr>
                    <tr>
                        <td align="center">Preset Call</td>
                    </tr>
                    <tr>
                        <td valign="top" height="5"></td>
                    </tr>
                    <tr>
                        <td align="center">
                            <div id="optStr"></div>
                        </td>
                    </tr>
                    <tr>
                        <td valign="top" height="10"></td>
                    </tr>
                    <tr>
                        <td align="center">PTZ Move Mode</td>
                    </tr>
                    <tr>
                        <td valign="top" height="5"></td>
                    </tr>
                    <tr>
                        <td align="center">
                            <select name=ptzMode style='width:143px;'>
                                <option value=0> Step
                                <option value=1 selected> Continuous
                            </select>
                        </td>
                    </tr>
                    <tr>
                        <td valign="top" height="10"></td>
                    </tr>
                    <tr>
                        <td align="center" valign="middle">PTZ Index&nbsp;
                            <select name=ptzIndex
                                style='width:70px;'>
                                <option value=0 selected> 1
                                <option value=1> 2
                                <option value=2> 3
                                <option value=3> 4
                                <option value=4> 5
                                <option value=5> 6
                                <option value=6> 7
                                <option value=7> 8
                            </select>
                        </td>
                    </tr>
                    <tr>
                        <td valign="top" height="10"></td>
                    </tr>
                    <tr>
                        <td align="center">
                            <table width="160" border="0" align="center" cellpadding="1" cellspacing="2">
                                <script language=javascript>
                                    PTZ_OPT_GROUP = 0x00004000;
                                    PTZ_OPT_TOUR = 0x00008000;
                                    PTZ_OPT_POWER = 0x00010000;
                                    PTZ_OPT_AUX0 = 0x00020000;
                                    PTZ_OPT_AUX1 = 0x00040000;
                                    PTZ_OPT_AUX2 = 0x00080000;
                                    PTZ_OPT_SCAN = 0x00200000;
                                    PTZ_OPT_PATTERN = 0x00400000;
                                    PTZ_OPT_IR = 0x00800000;
                                    PTZ_OPT_IRIS = 0x01000000;

                                    if (PTZFUNCOPTFLAG & PTZ_OPT_AUX0)
                                    {
                                        var str = "<tr align=\"center\"><td><img src=\"/img/ptz/aux1_on.bmp\" border=\"0\" title=\"AUX 1 On(Light)\" onClick=\"PtzOptCmdCtl('0x113');\" onMouseOver=\"this.src='/img/ptz/aux1_onOver.bmp'\" onMouseOut=\"this.src='/img/ptz/aux1_on.bmp'\"></td><td><img src=\"/img/ptz/aux1_off.bmp\" border=\"0\" title=\"AUX 1 Off(Light)\" onClick=\"PtzOptCmdCtl('0x114');\" onMouseOver=\"this.src='/img/ptz/aux1_offOver.bmp'\" onMouseOut=\"this.src='/img/ptz/aux1_off.bmp'\"></td></tr>";
                                        document.write(str);
                                    }
                                    if (PTZFUNCOPTFLAG & PTZ_OPT_AUX1)
                                    {
                                        var str = "<tr align=\"center\"><td><img src=\"/img/ptz/aux2_on.bmp\" border=\"0\" title=\"AUX 2 On\" onClick=\"PtzOptCmdCtl('0x115');\" onMouseOver=\"this.src='/img/ptz/aux2_onOver.bmp'\" onMouseOut=\"this.src='/img/ptz/aux2_on.bmp'\"></td><td><img src=\"/img/ptz/aux2_off.bmp\" border=\"0\" title=\"AUX 2 Off\" onClick=\"PtzOptCmdCtl('0x116');\" onMouseOver=\"this.src='/img/ptz/aux2_offOver.bmp'\" onMouseOut=\"this.src='/img/ptz/aux2_off.bmp'\"></td></tr>";
                                        document.write(str);
                                    }
                                    if (PTZFUNCOPTFLAG & PTZ_OPT_AUX2)
                                    {
                                        var str = "<tr align=\"center\"><td><img src=\"/img/ptz/aux3_on.bmp\" border=\"0\" title=\"AUX 3 On\" onClick=\"PtzOptCmdCtl('0x117');\" onMouseOver=\"this.src='/img/ptz/aux3_onOver.bmp'\" onMouseOut=\"this.src='/img/ptz/aux3_on.bmp'\"></td><td><img src=\"/img/ptz/aux3_off.bmp\" border=\"0\" title=\"AUX 3 Off\" onClick=\"PtzOptCmdCtl('0x118');\" onMouseOver=\"this.src='/img/ptz/aux3_offOver.bmp'\" onMouseOut=\"this.src='/img/ptz/aux3_off.bmp'\"></td></tr>";
                                        document.write(str);
                                    }
                                    if (PTZFUNCOPTFLAG & PTZ_OPT_GROUP)
                                    {
                                        var str = "<tr align=\"center\"><td><img src=\"/img/ptz/group_on.bmp\" border=\"0\" title=\"Group On\" onClick=\"PtzOptCmdCtl('0x11d');\" onMouseOver=\"this.src='/img/ptz/group_onOver.bmp'\" onMouseOut=\"this.src='/img/ptz/group_on.bmp'\"></td><td><img src=\"/img/ptz/group_off.bmp\" border=\"0\" title=\"Group Off\" onClick=\"PtzOptCmdCtl('0x11e');\" onMouseOver=\"this.src='/img/ptz/group_offOver.bmp'\" onMouseOut=\"this.src='/img/ptz/group_off.bmp'\"></td></tr>";
                                        document.write(str);
                                    }
                                    if (PTZFUNCOPTFLAG & PTZ_OPT_TOUR)
                                    {
                                        var str = "<tr align=\"center\"><td><img src=\"/img/ptz/tour_on.bmp\" border=\"0\" title=\"Tour On\" onClick=\"PtzOptCmdCtl('0x11f');\" onMouseOver=\"this.src='/img/ptz/tour_onOver.bmp'\" onMouseOut=\"this.src='/img/ptz/tour_on.bmp'\"></td><td><img src=\"/img/ptz/tour_off.bmp\" border=\"0\" title=\"Tour Off\" onClick=\"PtzOptCmdCtl('0x120');\" onMouseOver=\"this.src='/img/ptz/tour_offOver.bmp'\" onMouseOut=\"this.src='/img/ptz/tour_off.bmp'\"></td></tr>";
                                        document.write(str);
                                    }
                                    if (PTZFUNCOPTFLAG & PTZ_OPT_SCAN)
                                    {
                                        var str = "<tr align=\"center\"><td><img src=\"/img/ptz/scan_on.bmp\" border=\"0\" title=\"Scan On\" onClick=\"PtzOptCmdCtl('0x121');\" onMouseOver=\"this.src='/img/ptz/scan_onOver.bmp'\" onMouseOut=\"this.src='/img/ptz/scan_on.bmp'\"></td><td><img src=\"/img/ptz/scan_off.bmp\" border=\"0\" title=\"Scan Off\" onClick=\"PtzOptCmdCtl('0x122');\" onMouseOver=\"this.src='/img/ptz/scan_offOver.bmp'\" onMouseOut=\"this.src='/img/ptz/scan_off.bmp'\"></td></tr>";
                                        document.write(str);
                                    }
                                    if (PTZFUNCOPTFLAG & PTZ_OPT_PATTERN)
                                    {
                                        var str = "<tr align=\"center\"><td><img src=\"/img/ptz/pattern_on.bmp\" border=\"0\" title=\"Pattern On\" onClick=\"PtzOptCmdCtl('0x123');\" onMouseOver=\"this.src='/img/ptz/pattern_onOver.bmp'\" onMouseOut=\"this.src='/img/ptz/pattern_on.bmp'\"></td><td><img src=\"/img/ptz/pattern_off.bmp\" border=\"0\" title=\"Pattern Off\" onClick=\"PtzOptCmdCtl('0x124');\" onMouseOver=\"this.src='/img/ptz/pattern_offOver.bmp'\" onMouseOut=\"this.src='/img/ptz/pattern_off.bmp'\"></td></tr>";
                                        document.write(str);
                                    }
                                    if (PTZFUNCOPTFLAG & PTZ_OPT_IR)
                                    {
                                        var str = "<tr align=\"center\"><td><img src=\"/img/ptz/ir_on.bmp\" border=\"0\" title=\"Ir On\" onClick=\"PtzOptCmdCtl('0x127');\" onMouseOver=\"this.src='/img/ptz/ir_onOver.bmp'\" onMouseOut=\"this.src='/img/ptz/ir_on.bmp'\"></td><td><img src=\"/img/ptz/ir_off.bmp\" border=\"0\" title=\"Ir Off\" onClick=\"PtzOptCmdCtl('0x128');\" onMouseOver=\"this.src='/img/ptz/ir_offOver.bmp'\" onMouseOut=\"this.src='/img/ptz/ir_off.bmp'\"></td></tr>";
                                        document.write(str);
                                    }
                                    if (PTZFUNCOPTFLAG & PTZ_OPT_IRIS)
                                    {
                                        var str = "<tr align=\"center\"><td><img src=\"/img/ptz/iris_p.gif\" border=\"0\" title=\"AUX 3 On\" onClick=\"PtzOptCmdCtl('0x125');\" onMouseOver=\"this.src='/img/ptz/iris_pOver.gif'\" onMouseOut=\"this.src='/img/ptz/iris_p.gif'\"></td><td><img src=\"/img/ptz/iris_m.gif\" border=\"0\" title=\"AUX 3 Off\" onClick=\"PtzOptCmdCtl('0x126');\" onMouseOver=\"this.src='/img/ptz/iris_mOver.gif'\" onMouseOut=\"this.src='/img/ptz/iris_m.gif'\"></td></tr>";
                                        document.write(str);
                                    }
                                </script>
                            </table>
                        </td>
                    </tr>
                </table>
            </div>
        </td>
        <td width="100%" height="100%" align="center" valign="middle" bgcolor="#464646" id="TargetArea">
            <div style="display:block; width:100%; height:100%">
                <table border="0" align="center" cellpadding="0" cellspacing="0" bgcolor="#CCCCCC" style="width:100%; height:100%">
                    <tr>
                        <td align="center" style="width:100%; height:100%">
                            <div id="ViewerBox" style="width:100%; height:100%">
                                <div id="ViewerArea0"></div>
                                <div id="ViewerArea1"></div>
                                <div id="ViewerArea2"></div>
                                <div id="ViewerArea3"></div>
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
        </td>
    </tr>
</table>
</body>
</html>