<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <link rel="stylesheet" href="/style.css" type="text/css">
    <link rel="stylesheet" href="/js/jquery-ui.min.css" type="text/css">
    <style type="text/css">

    </style>
</head>
<body leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
    <table align=center cellpadding=0 cellspacing=0>
        <tr>
            <td>
                <video id="id_image" muted="muted" loop="loop" src="" type="video/mp4" style='width:500px; height:350px; background-color:#000000;' autoplay></video>
                <iframe src="" name=SetCgi frameborder="0" width="0" height="0" marginwidth="0" marginheight="0" scrolling="no"></iframe>
            </td>
        </tr>
        <tr>
            <td>
                <table border=0 cellspacing=0 cellpadding=0 align=left>
                    <tr>
                        <td width=160 height=30 align=center>
                            <input type=text name=ViewStartTime size=16 class=obj_Normal>

                        </td>
                        <td id="id_RecObj1" width=180 height=30 align=left>
                            &nbsp;~&nbsp;&nbsp;
                            <input type=text name=ViewEndTime size=16 class=obj_Normal>
                        </td>
                        <td id="id_RecObj2" width=150 height=30 align=right>
                            <input type=text name=DownloadProgress style="width:20px;" maxlength=2 class=obj_NoFont readonly>
                            <input type=text value="&#37;" style="width:15px;" maxlength=1 class=obj_NoFont readonly>
                        </td>
                    </tr>
                </table>
            </td>
        </tr>
        <tr>
            <td>
                <table border=0 width=420 cellspacing=0 cellpadding=0 align=center>
                    <tr>
                        <td>
                            <input id="toopen" type=button style='width:70px; height:25px;' value='&#9167;'>
                        </td>
                        <td>
                            <input id="toplay" type=button style='width:70px; height:25px;' value='&#9205;' disabled>
                        </td>
                        <td>
                            <input id="tonext" type=button style='width:70px; height:25px;' value='&#9197;' disabled>
                        </td>
                        <td>
                            <input id="topause" type=button style='width:70px; height:25px;' value='&#9208;' disabled>
                        </td>
                        <td>
                            <input id="tostop" type=button style='width:70px; height:25px;' value='&#9209;' disabled>
                        </td>
                        <td>
                            <input id="tobackup" type=button style='width:70px; height:25px;' value='Backup'>
                        </td>
                        <td>
                            <input id="torecord" type=button style='width:70px; height:25px;' value='&#9673;' disabled>
                        </td>
                    </tr>
                </table>
            </td>
        </tr>
    </table>
</body>
<script src="/js/jquery-3.6.0.min.js" type="text/javascript"></script>
<script src="/js/jquery-ui.min.js" type="text/javascript"></script>
<script src="/js/websocket/event.js" type="text/javascript"></script>
<script src="/js/websocket/jpegusr.js" type="text/javascript"></script>
<script src="/js/websocket/remuxer.js" type="text/javascript"></script>
<script src="/js/websocket/mp4.js" type="text/javascript"></script>
<script src="/js/websocket/videoconverter.js"></script>
<script src="/js/websocket/backupconverter.js"></script>
<script src="/js/websocket/FileSaver.js"></script>
<script language="javascript" type="text/javascript">
    var RecordData = [];
    var RecordName = "";
    var RecordFrame;
    var RecordFrameCount;

    var IP = document.location.hostname;
    var PORT = document.location.port;
    const listener = Symbol("event_listener");
    const listeners = Symbol("event_listeners"); 
    var ClientEventSource;
    var WebsockQueues={}; WebsockQueues[1]=[]; //video h.264
    var RecordWebsockQueues={}; RecordWebsockQueues[1]=[]; //video h.264
    var mimeType;
    var wsUri;
    var WebsockStatus = 0;
    var FirstWebsockFlag = 1;
    var IframeFlag = false;

    var playwebsocket;
    var recordwebsocket;
    const element = document.getElementById('id_image');
    var Converter;
    var RecordConverter;

    var Cur_Year = <% NssGetTimeYear(); %>;
    var Cur_Month = <% NssGetTimeMonth(); %>;
    var Cur_Day = <% NssGetTimeDay(); %>;
    var Cur_Hour = <% NssGetTimeHour(); %>;
    var Cur_Min = <% NssGetTimeMinute(); %>;
    var Cur_Sec = <% NssGetTimeSecond(); %>;
    //var fps = 0;
    var FPS = 30;
    var INTERVAL = 33;
    var SPEED = 1;
    var QUEUE_DEPTH = 3;
    var REC_STATUS = 0;

    var FlushHandler;
    var FlushRecordHandler;
    var client_eventSource = new EventEmitter();
    var RawImageQueue;
    var RawImage;
    var RecordRawImageQueue;
    var RecordRawImage;

    let VIDEO_STATUS_STOP = 0;
    let VIDEO_STATUS_PAUSE = 1;
    let VIDEO_STATUS_PLAY = 2;
    let VIDEO_STATUS_STEP_NEXT = 3;
   
    let FLOW_STATUS_STOP = 0;
    let FLOW_STATUS_START = 1;

    var VideoPlayModeFlag = VIDEO_STATUS_STOP;
    var VideoStepPrev = 0;
    var VideoStepNext = 0;
    var FlowControlStatus = FLOW_STATUS_STOP;

    window.addEventListener("load", init, false);

    var arrayBufferView;
    var jes_data;
    var rec_arrayBufferView;
    var rec_jes_data;

    function Flush() {
        for (let qidx in WebsockQueues) 
        {
            RawImageQueue = WebsockQueues[qidx];
            //console.log("qidx : " + qidx + " fps[" + fps +"] RawImageQueue.length : " + RawImageQueue.length);

            switch(VideoPlayModeFlag)
            {
                case VIDEO_STATUS_PLAY :
                    if( RawImageQueue.length < QUEUE_DEPTH )
                    {            
                        if ( FlowControlStatus == FLOW_STATUS_STOP )
                        {
                            doSend("start");
                            //console.log("VIDEO_STATUS_PLAY start : " + RawImageQueue.length);
                            FlowControlStatus = FLOW_STATUS_START;
                        }
                    }
                    else 
                    {
                        if (FlowControlStatus == FLOW_STATUS_START)
                        {
                            doSend("stop");
                            //console.log("VIDEO_STATUS_PLAY stop : " + RawImageQueue.length);
                            FlowControlStatus = FLOW_STATUS_STOP;
                        }
                    }
                    
                    if (RawImageQueue.length) 
                    {
                        RawImage = RawImageQueue.shift();

                        if (RawImage)
                        {
                            //console.log("Converter.appendRawData");
                            Converter.appendRawData(RawImage);
                            Converter.play();
                        }
                    }
                    break;
                case VIDEO_STATUS_STEP_NEXT :
                    if( RawImageQueue.length < 150 )
                    {            
                        if ( FlowControlStatus == FLOW_STATUS_STOP )
                        {
                            doSend("start");
                            //console.log("VIDEO_STATUS_STEP_NEXT start : " + RawImageQueue.length);
                            FlowControlStatus = FLOW_STATUS_START;
                        }
                    }
                    else 
                    {
                        if (FlowControlStatus == FLOW_STATUS_START)
                        {
                            doSend("stop");
                            //console.log("VIDEO_STATUS_STEP_NEXT stop : " + RawImageQueue.length);
                            FlowControlStatus = FLOW_STATUS_STOP;
                        }
                    }
                    break;
                case VIDEO_STATUS_PAUSE :
                    if ( FlowControlStatus == FLOW_STATUS_START )
                    {
                        doSend("stop");
                        //console.log("VIDEO_STATUS_PAUSE stop : " + RawImageQueue.length);
                        FlowControlStatus = FLOW_STATUS_STOP;
                    }
                    break;
                case VIDEO_STATUS_STOP :
                    if ( FlowControlStatus == FLOW_STATUS_START )
                    {
                        doSend("stop");
                        //console.log("VIDEO_STATUS_STOP stop : " + RawImageQueue.length);
                        FlowControlStatus = FLOW_STATUS_STOP;
                    }
                    break;
            }
        }
    }

    function ToStepNext() { //VIDEO_STATUS_STEP_NEXT
        if (RawImageQueue.length) 
        {
            //console.log("ToStepNext : " + RawImageQueue.length);
            for(var idx = 0; idx < RawImageQueue.length; idx++)
            {
                if( RawImage.isKeyframe() )
                {
                    //console.log("RawImage.isKeyframe");
                    Converter.appendRawData(RawImage);
                    //if (Converter.paused) {
                        Converter.play();
                    //}
                    RawImage = RawImageQueue.shift();
                    break;
                }
                else
                {
                    //console.log("RawImage.else");
                    RawImage = RawImageQueue.shift();
                }

                setTimeout(function() {
                    Converter.pause();
                }, INTERVAL);
            }
        }
    }

    function FlushRecord() {
        RecordRawImageQueue = RecordWebsockQueues[1];
        document.all.DownloadProgress.value = Math.floor(RecordFrameCount * 100 / RecordFrame);

        if( RecordRawImageQueue.length < QUEUE_DEPTH )
        {            
            if ( FlowControlStatus == FLOW_STATUS_STOP )
            {
                doRecordSend("start");
                //console.log("VIDEO_STATUS_PLAY start : " + RecordRawImageQueue.length);
                FlowControlStatus = FLOW_STATUS_START;
            }
        }
        else 
        {
            if (FlowControlStatus == FLOW_STATUS_START)
            {
                doRecordSend("stop");
                //console.log("VIDEO_STATUS_PLAY stop : " + RecordRawImageQueue.length);
                FlowControlStatus = FLOW_STATUS_STOP;
            }
        }


        if (RecordRawImageQueue.length) 
        {
            RecordRawImage = RecordRawImageQueue.shift();

            if (RecordRawImage)
            {
                //console.log("Record Status = [" + RecordFrameCount + "/" + RecordFrame + "]");
                RecordConverter.recordRawData(RecordRawImage);
            }
        }
    }

    function init() {
        with(document.all) {
            document.all.id_RecObj1.style.display = "none";
            document.all.id_RecObj2.style.display = "none";
            ViewStartTime.value = Cur_Year + "." + Cur_Month + "." + Cur_Day + ". " + Cur_Hour + ":" + Cur_Min + ":" + Cur_Sec;
            var DateStartTimeStamp = new Date(Cur_Year, ('00' + (Number(Cur_Month) - 1)).slice(-2), ('00' + Cur_Day).slice(-2), ('00' + Cur_Hour).slice(-2), ('00' + Cur_Min).slice(-2), ('00' + Cur_Sec).slice(-2));
        }
    }

    function onClose(evt) {
        console.log("!!!!!!!!!!!onClose!!!!!!!!!!!!!!");

        VideoPlayModeFlag = VIDEO_STATUS_STOP;
        setTimeout(function() {
            clearInterval(FlushHandler);
        }, INTERVAL * 2);

        playwebsocket.close();
        WebsockStatus = 0;

        WebsockQueues[0] = [];
        WebsockQueues[1] = [];
        RawImageQueue = [];
        RawImage = [];
        FirstWebsockFlag = 1;
        IframeFlag = false;
        jes_data = null;
        arrayBufferView = null;

        $("#toopen").attr("disabled", false);
        $("#toplay").attr("disabled", true);
        $("#tonext").attr("disabled", true);
        $("#topause").attr("disabled", true);
        $("#tostop").attr("disabled", true);
        $("#tobackup").attr("disabled", false);
        $("#torecord").attr("disabled", true);
    }

    function onRecordClose(evt) {
        console.log("!!!!!!!!!!!onRecordClose!!!!!!!!!!!!!!");

        const blob = new Blob(RecordData);
        saveAs(blob, RecordName);
        //console.log("RecordRawImage.Finish");
        document.all.DownloadProgress.value = 100;
        FlowControlStatus = FLOW_STATUS_STOP;

        WebsockStatus = 0;
        RecordWebsockQueues[0] = [];
        RecordWebsockQueues[1] = [];
        RecordRawImageQueue = [];
        RecordRawImage = [];
        FirstWebsockFlag = 1;

        RecordData = [];
        RecordName = "";

        IframeFlag = false;
        Recordjes_data = null;
        RecordarrayBufferView = null;

        {
            document.all.id_RecObj1.style.display = "none";
            document.all.id_RecObj2.style.display = "none";

            $("#toopen").attr("disabled", false);
            $("#toplay").attr("disabled", true);
            $("#tonext").attr("disabled", true);
            $("#topause").attr("disabled", true);
            $("#tostop").attr("disabled", true);
            $("#tobackup").attr("disabled", false);
            $("#torecord").attr("disabled", true);
            REC_STATUS = 0;
        }
        
        INTERVAL = 33;
        clearInterval(FlushRecordHandler);
    }

    function onMessage(evt)
    {
        switch(WebsockStatus)
        {
            case -1:
                break;
            case 0:
                onAuthMessage(evt);
                break;
            case 1:
                onJesMessage(evt);
                break;
        }
    }

    function onRecordMessage(evt)
    {
        switch(WebsockStatus)
        {
            case -1:
                break;
            case 0:
                onRecordAuthMessage(evt);
                break;
            case 1:
                onRecordJesMessage(evt);
                break;
        }
    }

    function onAuthMessage(evt)
    {
        var AuthJsonResponse = evt.data;
        try {
            var AuthJsonParse = JSON.parse(AuthJsonResponse);
            document.all.SetCgi.src = "/web/cgi-bin/app/ws_auth.cgi?ResponseCode=" + AuthJsonParse.response_code + "&Auth=" + AuthJsonParse.auth + "&Realm=" + AuthJsonParse.realm + "&Nonce=" + AuthJsonParse.nonce +  "&FwCgiVer=0x0001";
            WebsockStatus = 1;
        } catch {
            WebsockStatus = -1;
        } finally {
            switch(WebsockStatus)
            {
                case -1:
                    alert("Websocket authentication failed, Please reconnect again.");
                    break;
                default:
                    break;
            }
        }
    }

    function onRecordAuthMessage(evt)
    {
        var AuthJsonResponse = evt.data;
        try {
            var AuthJsonParse = JSON.parse(AuthJsonResponse);
            document.all.SetCgi.src = "/web/cgi-bin/app/ws_auth.cgi?ResponseCode=" + AuthJsonParse.response_code + "&Auth=" + AuthJsonParse.auth + "&Realm=" + AuthJsonParse.realm + "&Nonce=" + AuthJsonParse.nonce +  "&FwCgiVer=0x0001";
            WebsockStatus = 1;
        } catch {
            WebsockStatus = -1;
        } finally {
            switch(WebsockStatus)
            {
                case -1:
                    alert("Websocket authentication failed, Please reconnect again.");
                    break;
                default:
                    break;
            }
        }
    }

    function onJesMessage(evt)
    {
        arrayBufferView = new Uint8Array( evt.data );    
        jes_data = new jpeg_usr_t(arrayBufferView);

        if(jes_data.isKeyframe()) IframeFlag = true;

        if ( FirstWebsockFlag == 1 )
        {
            if (jes_data.codec_type == "H.265")
            {
                alert("H.265 is not surported, Please change another Encoding.");
            }

            if (jes_data.codec_type == "H.264")
            {
                if( jes_data.isKeyframe() )
                {
                    //console.log("isKeyframe !!");
                    mimeType = "video/mp4; codecs=" + jes_data.codec;
                    Converter = new VideoConverter(element, FPS, 1);
                    FirstWebsockFlag = 0;
                }
            }

            if (jes_data.codec_type == "MJPEG")
            {
                $("video").replaceWith("<img id='id_image' src=''></img>");
                FirstWebsockFlag = 0;
            }
        }

        if (jes_data.codec_type == "H.264")
        {
            if(IframeFlag)
            {
                //fps++;
                WebsockQueues[1].push(jes_data);
            }
        }
        else if (jes_data.codec_type == "MJPEG")
        {
            $("video").replaceWith("<img id='id_image' src=''></img>");
            var reader<% FwGetParmValue("PortId"); %> = new FileReader();
            reader<% FwGetParmValue("PortId"); %>.onload = function (evt) {
                if (evt.target.readyState == FileReader.DONE) {
                    //Base64 data
                    var url = evt.target.result;
                    document.getElementById("id_image").src = url;
                }
            }

            arrayBufferView = new Uint8Array(evt.data);
            var blob = new Blob([arrayBufferView], { type: "image/jpeg" });
            reader<% FwGetParmValue("PortId"); %>.readAsDataURL(blob);
            blob = null;
            arrayBufferView = null;
            reader<% FwGetParmValue("PortId"); %> = null;
        }

        jes_data = null;
        arrayBufferView = null;
    }

    function onRecordJesMessage(evt)
    {
        rec_arrayBufferView = new Uint8Array( evt.data );    
        rec_jes_data = new jpeg_usr_t(rec_arrayBufferView);

        if(rec_jes_data.isKeyframe()) IframeFlag = true;

        if ( FirstWebsockFlag == 1 )
        {
            if (rec_jes_data.codec_type == "H.265")
            {
                alert("H.265 is not surported, Please change another Encoding.");
            }

            if (rec_jes_data.codec_type == "H.264")
            {
                if( rec_jes_data.isKeyframe() )
                {
                    //console.log("isKeyframe !!");
                    mimeType = "video/mp4; codecs=" + rec_jes_data.codec;
                    RecordConverter = new VideoBackupConverter(element, FPS, 1);
                    FirstWebsockFlag = 0;
                }
            }

            if (rec_jes_data.codec_type == "MJPEG")
            {
                $("video").replaceWith("<img id='id_image' src=''></img>");
                FirstWebsockFlag = 0;
            }
        }

        if (rec_jes_data.codec_type == "H.264")
        {
            if(IframeFlag)
            {
                //fps++;
                RecordWebsockQueues[1].push(rec_jes_data);
            }
        }
        else if (rec_jes_data.codec_type == "MJPEG")
        {
            $("video").replaceWith("<img id='id_image' src=''></img>");
            var reader<% FwGetParmValue("PortId"); %> = new FileReader();
            reader<% FwGetParmValue("PortId"); %>.onload = function (evt) {
                if (evt.target.readyState == FileReader.DONE) {
                    //Base64 data
                    var url = evt.target.result;
                    document.getElementById("id_image").src = url;
                }
            }

            rec_arrayBufferView = new Uint8Array(evt.data);
            var blob = new Blob([rec_arrayBufferView], { type: "image/jpeg" });
            reader<% FwGetParmValue("PortId"); %>.readAsDataURL(blob);
            blob = null;
            rec_arrayBufferView = null;
            reader<% FwGetParmValue("PortId"); %> = null;
        }

        rec_jes_data = null;
        rec_arrayBufferView = null;
    }


    function onError(evt)
    {

    }

    function doSend(message)
    {
        playwebsocket.binaryType = 'arraybuffer';
            
        var bytearray = new Uint8Array( message.length );
        for ( var idx = 0; idx < message.length; ++idx ) {
            bytearray[idx] = message[idx].charCodeAt(0);
        }
        playwebsocket.send(bytearray.buffer);
    }

    function doRecordSend(message)
    {
        recordwebsocket.binaryType = 'arraybuffer';
            
        var bytearray = new Uint8Array( message.length );
        for ( var idx = 0; idx < message.length; ++idx ) {
            bytearray[idx] = message[idx].charCodeAt(0);
        }
        recordwebsocket.send(bytearray.buffer);
    }

    $(function() {
        $("#toopen").click(function() {    //Open
            VideoPlayModeFlag = VIDEO_STATUS_PLAY;
            var StrStartTime = document.all.ViewStartTime.value;
            var StartTime;
            var StrStartTimePre;

            StartTime = StrStartTime.split(' ');
            StrStartTimePre = StartTime[0].split('.');
            StrStartTimeTail = StartTime[1].split(':');
            
            var StartTimeValue = StrStartTimePre[0] + "-" + StrStartTimePre[1] + "-" + StrStartTimePre[2] + "-" + StrStartTimeTail[0] + "-" + StrStartTimeTail[1] + "-" + StrStartTimeTail[2];
            var EndTimeValue = StrStartTimePre[0] + "-" + "12" + "-" + "31" + "-" + "23" + "-" + "59" + "-" + "59";

            if (document.location.protocol == 'https:')
            {
                wsUri = "wss://" + IP + ":" + PORT + "/ws/FlexWatch-WebSocket?ServerId=0&AppKey=0x00000029&PortId=<% FwGetParmValue("PortId"); %>&SearchTime=" + StartTimeValue + "&PauseTime=" + EndTimeValue + "&SearchMode=1&FwCgiVer=0x0001";
            }
            else
            {
                wsUri = "ws://" + IP + ":" + PORT + "/ws/FlexWatch-WebSocket?ServerId=0&AppKey=0x00000029&PortId=<% FwGetParmValue("PortId"); %>&SearchTime=" + StartTimeValue + "&PauseTime=" + EndTimeValue + "&SearchMode=1&FwCgiVer=0x0001";
            }

            playwebsocket = new WebSocket(wsUri,["nipp"]);
            playwebsocket.onclose = function(evt) { onClose(evt) };
            playwebsocket.onmessage = function(evt) { onMessage(evt) };
            playwebsocket.onerror = function(evt) { onError(evt) };

            ClientEventSource = new EventSourceWrapper(client_eventSource);
            ClientEventSource.on('Flush', Flush.bind(this));

            setTimeout(function() {
                FlushHandler = setInterval(()=>{
                    client_eventSource.dispatchEvent('Flush');
                }, INTERVAL);
            }, 50);

            $("#toopen").attr("disabled", true);
            $("#toplay").attr("disabled", true);
            $("#tonext").attr("disabled", true);
            $("#topause").attr("disabled", false);
            $("#tostop").attr("disabled", false);
            $("#tobackup").attr("disabled", true);
            $("#torecord").attr("disabled", true);
        });

        $("#toplay").click(function() {    //Play
            VideoPlayModeFlag = VIDEO_STATUS_PLAY;
            FlushHandler = setInterval(()=>{
                client_eventSource.dispatchEvent('Flush');
            }, INTERVAL);

            $("#toopen").attr("disabled", true);
            $("#toplay").attr("disabled", true);
            $("#tonext").attr("disabled", true);
            $("#topause").attr("disabled", false);
            $("#tostop").attr("disabled", false);
            $("#tobackup").attr("disabled", true);
            $("#torecord").attr("disabled", true);
        });
/*
        $("#tonext").click(function() {    //Next Move
            VideoPlayModeFlag = VIDEO_STATUS_STEP_NEXT;

            setTimeout(function() {
                clearInterval(FlushHandler);
            }, INTERVAL * 2);
            Converter.pause();

            if( RawImageQueue.length < 200 )
            {
                FlushHandler = setInterval(()=>{
                client_eventSource.dispatchEvent('Flush');
                }, INTERVAL);
            }
        });
*/
        $("#tonext").click(function() {    //Next Move
            VideoPlayModeFlag = VIDEO_STATUS_STEP_NEXT;
            FlushHandler = setInterval(()=>{
                client_eventSource.dispatchEvent('Flush');
            }, INTERVAL);
            Converter.pause();
            ToStepNext();

            $("#toopen").attr("disabled", true);
            $("#toplay").attr("disabled", false);
            $("#tonext").attr("disabled", false);
            $("#topause").attr("disabled", true);
            $("#tostop").attr("disabled", false);
            $("#tobackup").attr("disabled", true);
            $("#torecord").attr("disabled", true);
        });

        $("#topause").click(function() {    //Pause
            VideoPlayModeFlag = VIDEO_STATUS_PAUSE;
            Converter.pause();
            setTimeout(function() {
                clearInterval(FlushHandler);
            }, INTERVAL * 2);
            
            $("#toopen").attr("disabled", true);
            $("#toplay").attr("disabled", false);
            $("#tonext").attr("disabled", false);
            $("#topause").attr("disabled", true);
            $("#tostop").attr("disabled", false);
            $("#tobackup").attr("disabled", true);
            $("#torecord").attr("disabled", true);
        });

        $("#tostop").click(function() {    //Stop
            VideoPlayModeFlag = VIDEO_STATUS_STOP;
            Converter.pause();
            Converter.reset();
            setTimeout(function() {
                clearInterval(FlushHandler);
            }, INTERVAL * 2);

            playwebsocket.close();
            WebsockStatus = 0;

            WebsockQueues[0] = [];
            WebsockQueues[1] = [];
            RawImageQueue = [];
            RawImage = [];
            FirstWebsockFlag = 1;
            IframeFlag = false;
            jes_data = null;
            arrayBufferView = null;

            $("#toopen").attr("disabled", false);
            $("#toplay").attr("disabled", true);
            $("#tonext").attr("disabled", true);
            $("#topause").attr("disabled", true);
            $("#tostop").attr("disabled", true);
            $("#tobackup").attr("disabled", false);
            $("#torecord").attr("disabled", true);
        });

        $("#tobackup").click(function() {    //Backup
            if (!REC_STATUS)
            {
                document.all.id_RecObj1.style.display = "";
                document.all.id_RecObj2.style.display = "";

                $("#tobackup").val("Playback");

                var StrStartTime = document.all.ViewStartTime.value;
                var StartTime;
                var StrStartTimePre;
                var StrStartTimeTail;
                StartTime = StrStartTime.split(' ');
                StrStartTimePre = StartTime[0].split('.');
                StrStartTimeTail = StartTime[1].split(':');
                
                var StartTimeValue = StrStartTimePre[0] + "-" + StrStartTimePre[1] + "-" + StrStartTimePre[2] + "-" + StrStartTimeTail[0] + "-" + StrStartTimeTail[1] + "-" + StrStartTimeTail[2];
                var DateStartTimeStamp = new Date(StrStartTimePre[0], ('00' + (Number(StrStartTimePre[1]) - 1)).slice(-2), ('00' + StrStartTimePre[2]).slice(-2), ('00' + StrStartTimeTail[0]).slice(-2), ('00' + StrStartTimeTail[1]).slice(-2), ('00' + StrStartTimeTail[2]).slice(-2));
                var DateEndTimeStamp = new Date(DateStartTimeStamp.getTime() + 300000);
                document.all.ViewEndTime.value = DateEndTimeStamp.getFullYear() + "." + (Number(DateEndTimeStamp.getMonth()) + 1) + "." + DateEndTimeStamp.getDate() + ". " + ('00' + DateEndTimeStamp.getHours()).slice(-2) + ":" + ('00' + DateEndTimeStamp.getMinutes()).slice(-2) + ":" + ('00' + DateEndTimeStamp.getSeconds()).slice(-2);

                $("#toopen").attr("disabled", true);
                $("#toplay").attr("disabled", true);
                $("#tonext").attr("disabled", true);
                $("#topause").attr("disabled", true);
                $("#tostop").attr("disabled", true);
                $("#tobackup").attr("disabled", false);
                $("#torecord").attr("disabled", false);

                REC_STATUS = 1;
            }
            else
            {
                document.all.id_RecObj1.style.display = "none";
                document.all.id_RecObj2.style.display = "none";

                $("#tobackup").val("Backup");

                $("#toopen").attr("disabled", false);
                $("#toplay").attr("disabled", true);
                $("#tonext").attr("disabled", true);
                $("#topause").attr("disabled", true);
                $("#tostop").attr("disabled", true);
                $("#tobackup").attr("disabled", false);
                $("#torecord").attr("disabled", true);
                REC_STATUS = 0;
            }
        });

        $("#torecord").click(function() {    //Record Start
            INTERVAL = 5;

            VideoPlayModeFlag = VIDEO_STATUS_PLAY;
            var StrStartTime = document.all.ViewStartTime.value;
            var StrEndTime = document.all.ViewEndTime.value;

            var StartTime, EndTime;
            var StrStartTimePre, StrEndTimePre;
            var StrStartTimeTail, StrEndTimeTail;

            StartTime = StrStartTime.split(' ');
            StrStartTimePre = StartTime[0].split('.');
            StrStartTimeTail = StartTime[1].split(':');
            EndTime = StrEndTime.split(' ');
            StrEndTimePre = EndTime[0].split('.');
            StrEndTimeTail = EndTime[1].split(':');
            
            var StartTimeValue = StrStartTimePre[0] + "-" + StrStartTimePre[1] + "-" + StrStartTimePre[2] + "-" + StrStartTimeTail[0] + "-" + StrStartTimeTail[1] + "-" + StrStartTimeTail[2];
            var EndTimeValue = StrEndTimePre[0] + "-" + StrEndTimePre[1] + "-" + StrEndTimePre[2] + "-" + StrEndTimeTail[0] + "-" + StrEndTimeTail[1] + "-" + StrEndTimeTail[2];
            var DateStartTimeStamp = new Date(StrStartTimePre[0], ('00' + (Number(StrStartTimePre[1]) - 1)).slice(-2), ('00' + StrStartTimePre[2]).slice(-2), ('00' + StrStartTimeTail[0]).slice(-2), ('00' + StrStartTimeTail[1]).slice(-2), ('00' + StrStartTimeTail[2]).slice(-2));
            var DateEndTimeStamp = new Date(StrEndTimePre[0], ('00' + (Number(StrEndTimePre[1]) - 1)).slice(-2), ('00' + StrEndTimePre[2]).slice(-2), ('00' + StrEndTimeTail[0]).slice(-2), ('00' + StrEndTimeTail[1]).slice(-2), ('00' + StrEndTimeTail[2]).slice(-2));

            if( (DateEndTimeStamp - DateStartTimeStamp) <= 0)
            {
                alert("Wrong Time");
                return false;
            }
            else if( (DateEndTimeStamp - DateStartTimeStamp) > 300000)
            {
                alert("Save Limit is 5 Minute");
                return false;
            }

            RecordFrame = 30 * (DateEndTimeStamp - DateStartTimeStamp) / 1000;
            RecordFrameCount = 0;
            RecordName = StrStartTimePre[0] + "_" + StrStartTimePre[1] + "_" + StrStartTimePre[2] + "_" + StrStartTimeTail[0] + "_" + StrStartTimeTail[1] + ".mp4";

            if (document.location.protocol == 'https:')
            {
                wsUri = "wss://" + IP + ":" + PORT + "/ws/FlexWatch-WebSocket?ServerId=0&AppKey=0x00000029&PortId=<% FwGetParmValue("PortId"); %>&SearchTime=" + StartTimeValue + "&PauseTime=" + EndTimeValue + "&SearchMode=1&FwCgiVer=0x0001";
            }
            else
            {
                wsUri = "ws://" + IP + ":" + PORT + "/ws/FlexWatch-WebSocket?ServerId=0&AppKey=0x00000029&PortId=<% FwGetParmValue("PortId"); %>&SearchTime=" + StartTimeValue + "&PauseTime=" + EndTimeValue + "&SearchMode=1&FwCgiVer=0x0001";
            }

            recordwebsocket = new WebSocket(wsUri,["nipp"]);
            recordwebsocket.onclose = function(evt) { onRecordClose(evt) };
            recordwebsocket.onmessage = function(evt) { onRecordMessage(evt) };
            recordwebsocket.onerror = function(evt) { onError(evt) };

            ClientEventSource = new EventSourceWrapper(client_eventSource);
            ClientEventSource.on('FlushRecord', FlushRecord.bind(this));

            setTimeout(function() {
                FlushRecordHandler = setInterval(()=>{
                    client_eventSource.dispatchEvent('FlushRecord');
                }, INTERVAL);
            }, 50);

            $("#toopen").attr("disabled", true);
            $("#toplay").attr("disabled", true);
            $("#tonext").attr("disabled", true);
            $("#topause").attr("disabled", true);
            $("#tostop").attr("disabled", true);
            $("#tobackup").attr("disabled", true);
            $("#torecord").attr("disabled", true);
        });
    });
</script>
</html>
