<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <link rel="stylesheet" href="/js/jquery-ui.min.css" type="text/css">
    <style type="text/css">
        #id_PlaySpeedSlider { width:180px; display:inline-block; height: .1em; vertical-align: middle; }
        #id_PlaySpeedSlider .ui-slider-handle { position: absolute; top: -8px; background: #F8F9FA; border-radius: 50%; }
    </style>
</head>
<body leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
    <table align=center cellpadding=0 cellspacing=0>
        <tr>
            <td>
                <video id="id_image" muted="muted" loop="loop" src="" type="video/mp4" style='width:500px; height:350px; background-color:#000000;' autoplay></video>
                <iframe src="" name=SetCgi frameborder="0" width="0" height="0" marginwidth="0" marginheight="0" scrolling="no"></iframe>
            </td>
        </tr>
        <tr>
            <td>
                <table cellspacing=0 cellpadding=0 align=center class=tbl_Normal>
                    <tr>
                        <td width=300 align=center rowspan=2>
                            <input type=text name=ViewStartTime size=13 class=obj_Normal>
                            ~
                            <input type=text name=ViewEndTime size=13 class=obj_Normal>
                        </td>
                        <td width=210 align=center>
                            <div id="id_PlaySpeedSlider"></div>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <table cellspacing=0 cellpadding=0 align=center class=tbl_Normal>
                                <tr>
                                    <td width=70 align=center>
                                        Slow
                                    </td>
                                    <td width=70 align=center>
                                        Normal
                                    </td>
                                    <td width=70 align=center>
                                        Fast
                                    </td>
                                </tr>
                            </table> 
                        </td>
                    </tr>
                </table>
            </td>
        </tr>
        <tr>
            <td>
                <table width=420 cellspacing=0 cellpadding=0 align=center class=tbl_Normal>
                    <tr>
                        <td colspan="7">
                            <input type=text name=DownloadProgress size=6 maxlength=4 class=obj_NoFont>&#37;
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <input id="button1" type=button class=obj_Button style='width:60px;' value='&#9167;'>
                        </td>
                        <td>
                            <input id="button2" type=button class=obj_Button style='width:60px;' value='&#9205;' disabled>
                        </td>
                        <td>
                            <input id="button3" type=button class=obj_Button style='width:60px;' value='&#9204;' disabled>
                        </td>
                        <td>
                            <input id="button4" type=button class=obj_Button style='width:60px;' value='&#9197;' disabled>
                        </td>
                        <td>
                            <input id="button5" type=button class=obj_Button style='width:60px;' value='&#9198;' disabled>
                        </td>
                        <td>
                            <input id="button6" type=button class=obj_Button style='width:60px;' value='&#9208;' disabled>
                        </td>
                        <td>
                            <input id="button7" type=button class=obj_Button style='width:60px;' value='&#9209;' disabled>
                        </td>
                        <td>
                            <input id="button8" type=button class=obj_Button style='width:60px;' value='&#9673;'>
                        </td>
                    </tr>
                </table>
            </td>
        </tr>
    </table>
</body>
<script src="/js/jquery-3.6.0.min.js" type="text/javascript"></script>
<script src="/js/jquery-ui.min.js" type="text/javascript"></script>
<script src="/js/websocket/event.js" type="text/javascript"></script>
<script src="/js/websocket/jpegusr.js" type="text/javascript"></script>
<script src="/js/websocket/remuxer.js" type="text/javascript"></script>
<script src="/js/websocket/mp4.js" type="text/javascript"></script>
<script src="/js/websocket/videoconverter.js"></script>
<script src="/js/websocket/backupconverter.asp"></script>
<script src="/js/websocket/FileSaver.js"></script>
<script language="javascript" type="text/javascript">
    var RecordData = [];
    var RecordName = "";
    var RecordFrame;
    var RecordFrameCount;

    var IP = document.location.hostname;
    var PORT = document.location.port;
    const listener = Symbol("event_listener");
    const listeners = Symbol("event_listeners"); 
    var ClientEventSource;
    var WebsockQueues={}; WebsockQueues[1]=[]; //video h.264
    var RecordWebsockQueues={}; RecordWebsockQueues[1]=[]; //video h.264
    var mimeType;
    var wsUri;
    var WebsockStatus = 0;
    var FirstWebsockFlag = 1;
    var IframeFlag = false;

    var playwebsocket;
    var recordwebsocket;
    const element = document.getElementById('id_image');
    var Converter;
    var RecordConverter;


    var Cur_Year = <% NssGetTimeYear(); %>;
    var Cur_Month = <% NssGetTimeMonth(); %>;
    var Cur_Day = <% NssGetTimeDay(); %>;
    var Cur_Hour = <% NssGetTimeHour(); %>;
    var Cur_Min = <% NssGetTimeMinute(); %>;
    var Cur_Sec = <% NssGetTimeSecond(); %>;
    //var fps = 0;
    var FPS = 30;
    var INTERVAL = 33;
    var SPEED = 1;
    var QUEUE_DEPTH = 3;

    var FlushHandler;
    var FlushRecordHandler;
    var client_eventSource = new EventEmitter();
    var RawImageQueue;
    var RawImage;
    var RecordRawImageQueue;
    var RecordRawImage;

    let VIDEO_STATUS_STOP = 0;
    let VIDEO_STATUS_PAUSE = 1;
    let VIDEO_STATUS_PLAY = 2;
    let VIDEO_STATUS_STEP_NEXT = 2;
   
    let FLOW_STATUS_STOP = 0;
    let FLOW_STATUS_START = 1;

    var VideoPlayModeFlag = VIDEO_STATUS_STOP;
    var VideoStepPrev = 0;
    var VideoStepNext = 0;
    var FlowControlStatus = FLOW_STATUS_STOP;

    window.addEventListener("load", init, false);

    var arrayBufferView;
    var jes_data;
    var rec_arrayBufferView;
    var rec_jes_data;

    function Flush() {
        for (let qidx in WebsockQueues) 
        {
            RawImageQueue = WebsockQueues[qidx];
            //console.log("qidx : " + qidx + " fps[" + fps +"] RawImageQueue.length : " + RawImageQueue.length);

            switch(VideoPlayModeFlag)
            {
                case VIDEO_STATUS_PLAY :
                    if( RawImageQueue.length < QUEUE_DEPTH )
                    {            
                        if ( FlowControlStatus == FLOW_STATUS_STOP )
                        {
                            doSend("start");
                            //console.log("VIDEO_STATUS_PLAY start : " + RawImageQueue.length);
                            FlowControlStatus = FLOW_STATUS_START;
                        }
                    }
                    else 
                    {
                        if (FlowControlStatus == FLOW_STATUS_START)
                        {
                            doSend("stop");
                            //console.log("VIDEO_STATUS_PLAY stop : " + RawImageQueue.length);
                            FlowControlStatus = FLOW_STATUS_STOP;
                        }
                    }
                    
                    if (RawImageQueue.length) 
                    {
                        RawImage = RawImageQueue.shift();

                        if (RawImage)
                        {
                            //console.log("Converter.appendRawData");
                            Converter.appendRawData(RawImage);
                            Converter.play();
                        }
                    }
                    break;
                case VIDEO_STATUS_STEP_NEXT :
                    doSend("start");
                    console.log("start");
                    
                    setTimeout(function() {
                        doSend("stop");
                        console.log("stop");
                    }, 5);

                    if (RawImageQueue.length) 
                    {
                        for(var idx; idx < RawImageQueue.length; idx++ )
                        {
                            if( RawImage.isKeyframe() )
                            {
                                break;
                            }
                            else
                            {
                                RawImage = RawImageQueue.shift();
                            }
                        }

                        if (RawImage)
                        {
                            console.log("Converter.appendRawData");
                            Converter.appendRawData(RawImage);
                            Converter.play();
                        }
                    }
                    break;
                case VIDEO_STATUS_PAUSE :
                    if ( FlowControlStatus == FLOW_STATUS_START )
                    {
                        doSend("stop");
                        //console.log("VIDEO_STATUS_PAUSE stop : " + RawImageQueue.length);
                        FlowControlStatus = FLOW_STATUS_STOP;
                    }
                    break;
                case VIDEO_STATUS_STOP :
                    if ( FlowControlStatus == FLOW_STATUS_START )
                    {
                        doSend("stop");
                        //console.log("VIDEO_STATUS_STOP stop : " + RawImageQueue.length);
                        FlowControlStatus = FLOW_STATUS_STOP;
                    }
                    break;
            }
        }
    }

    function FlushRecord() {
        RecordRawImageQueue = RecordWebsockQueues[1];
        document.all.DownloadProgress.value = Math.floor(RecordFrameCount * 100 / RecordFrame);

        if( RecordRawImageQueue.length < QUEUE_DEPTH )
        {            
            if ( FlowControlStatus == FLOW_STATUS_STOP )
            {
                doRecordSend("start");
                //console.log("VIDEO_STATUS_PLAY start : " + RecordRawImageQueue.length);
                FlowControlStatus = FLOW_STATUS_START;
            }
        }
        else 
        {
            if (FlowControlStatus == FLOW_STATUS_START)
            {
                doRecordSend("stop");
                //console.log("VIDEO_STATUS_PLAY stop : " + RecordRawImageQueue.length);
                FlowControlStatus = FLOW_STATUS_STOP;
            }
        }

        if (RecordRawImageQueue.length) 
        {
            RecordRawImage = RecordRawImageQueue.shift();

            if (RecordRawImage)
            {
                console.log("Record Status = [" + RecordFrameCount + "/" + RecordFrame + "]");
                //console.log("RecordRawImage.recordRawData");
                RecordConverter.recordRawData(RecordRawImage);
            }
        }

        if(RecordFrameCount >= RecordFrame)
        {
            const blob = new Blob(RecordData);
            saveAs(blob, RecordName);
            console.log("RecordRawImage.Finish");
            document.all.DownloadProgress.value = 100;
            RecordConverter.pause();
            RecordConverter.reset();
            doRecordSend("stop");

            recordwebsocket.close();
            WebsockStatus = 0;

            RecordWebsockQueues[0] = [];
            RecordWebsockQueues[1] = [];
            RecordRawImageQueue = [];
            RecordRawImage = [];
            FirstWebsockFlag = 1;
            IframeFlag = false;
            Recordjes_data = null;
            RecordarrayBufferView = null;

            $('#id_PlaySpeedSlider').slider({ disabled: false });
            $("#button1").attr("disabled", false);
            $("#button2").attr("disabled", true);
            $("#button3").attr("disabled", true);
            $("#button4").attr("disabled", true);
            $("#button5").attr("disabled", true);
            $("#button6").attr("disabled", true);
            $("#button7").attr("disabled", true);
            $("#button8").attr("disabled", false);
            
            clearInterval(FlushRecordHandler);
        }
    }

    function init() {
        with(document.all) {
            ViewStartTime.value = Cur_Year + "." + Cur_Month + "." + Cur_Day + ". " + Cur_Hour + ":" + Cur_Min + ":" + Cur_Sec;
            var DateStartTimeStamp = new Date(Cur_Year, ('00' + (Number(Cur_Month) - 1)).slice(-2), ('00' + Cur_Day).slice(-2), ('00' + Cur_Hour).slice(-2), ('00' + Cur_Min).slice(-2), ('00' + Cur_Sec).slice(-2));
            var DateEndTimeStamp = new Date(DateStartTimeStamp.getTime() + 300000);
            ViewEndTime.value = DateEndTimeStamp.getFullYear() + "." + Number(DateEndTimeStamp.getMonth() + 1) + "." + DateEndTimeStamp.getDate() + ". " + String(DateEndTimeStamp.getHours()).padStart(2, '0') + ":" + String(DateEndTimeStamp.getMinutes()).padStart(2, '0') + ":" + String(DateEndTimeStamp.getSeconds()).padStart(2, '0');
/*
            setInterval(function(){
                //console.log("fps[" + fps +"]");
                fps = 0;
            }, 1000);
*/
        }
    }

    function onClose(evt) {

    }

    function onMessage(evt)
    {
        switch(WebsockStatus)
        {
            case -1:
                break;
            case 0:
                onAuthMessage(evt);
                break;
            case 1:
                onJesMessage(evt);
                break;
        }
    }

    function onRecordMessage(evt)
    {
        switch(WebsockStatus)
        {
            case -1:
                break;
            case 0:
                onRecordAuthMessage(evt);
                break;
            case 1:
                onRecordJesMessage(evt);
                break;
        }
    }

    function onAuthMessage(evt)
    {
        var AuthJsonResponse = evt.data;
        try {
            var AuthJsonParse = JSON.parse(AuthJsonResponse);
            document.all.SetCgi.src = "/web/cgi-bin/app/ws_auth.cgi?ResponseCode=" + AuthJsonParse.response_code + "&Auth=" + AuthJsonParse.auth + "&Realm=" + AuthJsonParse.realm + "&Nonce=" + AuthJsonParse.nonce +  "&FwCgiVer=0x0001";
            WebsockStatus = 1;
        } catch {
            WebsockStatus = -1;
        } finally {
            switch(WebsockStatus)
            {
                case -1:
                    alert("Websocket authentication failed, Please reconnect again.");
                    break;
                default:
                    break;
            }
        }
    }

    function onRecordAuthMessage(evt)
    {
        var AuthJsonResponse = evt.data;
        try {
            var AuthJsonParse = JSON.parse(AuthJsonResponse);
            document.all.SetCgi.src = "/web/cgi-bin/app/ws_auth.cgi?ResponseCode=" + AuthJsonParse.response_code + "&Auth=" + AuthJsonParse.auth + "&Realm=" + AuthJsonParse.realm + "&Nonce=" + AuthJsonParse.nonce +  "&FwCgiVer=0x0001";
            WebsockStatus = 1;
        } catch {
            WebsockStatus = -1;
        } finally {
            switch(WebsockStatus)
            {
                case -1:
                    alert("Websocket authentication failed, Please reconnect again.");
                    break;
                default:
                    break;
            }
        }
    }

    function onJesMessage(evt)
    {
        arrayBufferView = new Uint8Array( evt.data );    
        jes_data = new jpeg_usr_t(arrayBufferView);

        if(jes_data.isKeyframe()) IframeFlag = true;

        if ( FirstWebsockFlag == 1 )
        {
            if (jes_data.codec_type == "H.265")
            {
                alert("H.265 is not surported, Please change another Encoding.");
            }

            if (jes_data.codec_type == "H.264")
            {
                if( jes_data.isKeyframe() )
                {
                    //console.log("isKeyframe !!");
                    mimeType = "video/mp4; codecs=" + jes_data.codec;
                    Converter = new VideoConverter(element, FPS, 1);
                    FirstWebsockFlag = 0;
                }
            }

            if (jes_data.codec_type == "MJPEG")
            {
                $("video").replaceWith("<img id='id_image' src=''></img>");
                FirstWebsockFlag = 0;
            }
        }

        if (jes_data.codec_type == "H.264")
        {
            if(IframeFlag)
            {
                //fps++;
                WebsockQueues[1].push(jes_data);
            }
        }
        else if (jes_data.codec_type == "MJPEG")
        {
            $("video").replaceWith("<img id='id_image' src=''></img>");
            var reader<% FwGetParmValue("PortId"); %> = new FileReader();
            reader<% FwGetParmValue("PortId"); %>.onload = function (evt) {
                if (evt.target.readyState == FileReader.DONE) {
                    //Base64 data
                    var url = evt.target.result;
                    document.getElementById("id_image").src = url;
                }
            }

            arrayBufferView = new Uint8Array(evt.data);
            var blob = new Blob([arrayBufferView], { type: "image/jpeg" });
            reader<% FwGetParmValue("PortId"); %>.readAsDataURL(blob);
            blob = null;
            arrayBufferView = null;
            reader<% FwGetParmValue("PortId"); %> = null;
        }

        jes_data = null;
        arrayBufferView = null;
    }

    function onRecordJesMessage(evt)
    {
        rec_arrayBufferView = new Uint8Array( evt.data );    
        rec_jes_data = new jpeg_usr_t(rec_arrayBufferView);

        if(rec_jes_data.isKeyframe()) IframeFlag = true;

        if ( FirstWebsockFlag == 1 )
        {
            if (rec_jes_data.codec_type == "H.265")
            {
                alert("H.265 is not surported, Please change another Encoding.");
            }

            if (rec_jes_data.codec_type == "H.264")
            {
                if( rec_jes_data.isKeyframe() )
                {
                    //console.log("isKeyframe !!");
                    mimeType = "video/mp4; codecs=" + rec_jes_data.codec;
                    RecordConverter = new VideoBackupConverter(element, FPS, 1);
                    FirstWebsockFlag = 0;
                }
            }

            if (rec_jes_data.codec_type == "MJPEG")
            {
                $("video").replaceWith("<img id='id_image' src=''></img>");
                FirstWebsockFlag = 0;
            }
        }

        if (rec_jes_data.codec_type == "H.264")
        {
            if(IframeFlag)
            {
                //fps++;
                RecordWebsockQueues[1].push(rec_jes_data);
            }
        }
        else if (rec_jes_data.codec_type == "MJPEG")
        {
            $("video").replaceWith("<img id='id_image' src=''></img>");
            var reader<% FwGetParmValue("PortId"); %> = new FileReader();
            reader<% FwGetParmValue("PortId"); %>.onload = function (evt) {
                if (evt.target.readyState == FileReader.DONE) {
                    //Base64 data
                    var url = evt.target.result;
                    document.getElementById("id_image").src = url;
                }
            }

            rec_arrayBufferView = new Uint8Array(evt.data);
            var blob = new Blob([rec_arrayBufferView], { type: "image/jpeg" });
            reader<% FwGetParmValue("PortId"); %>.readAsDataURL(blob);
            blob = null;
            rec_arrayBufferView = null;
            reader<% FwGetParmValue("PortId"); %> = null;
        }

        rec_jes_data = null;
        rec_arrayBufferView = null;
    }


    function onError(evt)
    {

    }

    function doSend(message)
    {
        playwebsocket.binaryType = 'arraybuffer';
            
        var bytearray = new Uint8Array( message.length );
        for ( var idx = 0; idx < message.length; ++idx ) {
            bytearray[idx] = message[idx].charCodeAt(0);
        }
        playwebsocket.send(bytearray.buffer);
    }

    function doRecordSend(message)
    {
        recordwebsocket.binaryType = 'arraybuffer';
            
        var bytearray = new Uint8Array( message.length );
        for ( var idx = 0; idx < message.length; ++idx ) {
            bytearray[idx] = message[idx].charCodeAt(0);
        }
        recordwebsocket.send(bytearray.buffer);
    }

    $(function() {
        $("#id_PlaySpeedSlider").slider({
            value: 1,
            min: 0,
            max: 2,
            step: 1,

            slide: function(event, ui) {
                if(ui.value == 0)
                {
                    //clearInterval(FlushHandler);
                    FPS = 10;
                    INTERVAL = 100;
                    SPEED = 0;
                    QUEUE_DEPTH = 3;
/*
                    FlushHandler = setInterval(()=>{
                        client_eventSource.dispatchEvent('Flush');
                    }, INTERVAL);
*/
                }
                else if(ui.value == 1)
                {
                    //clearInterval(FlushHandler);
                    FPS = 30;
                    INTERVAL = 33;
                    SPEED = 1;
                    QUEUE_DEPTH = 3;

/*
                    FlushHandler = setInterval(()=>{
                        client_eventSource.dispatchEvent('Flush');
                    }, INTERVAL);
*/
                }
                else if(ui.value == 2)
                {
                    //clearInterval(FlushHandler);
                    FPS = 340;
                    INTERVAL = 3;
                    SPEED = 2;
                    QUEUE_DEPTH = 100;

/*
                    FlushHandler = setInterval(()=>{
                        client_eventSource.dispatchEvent('Flush');
                    }, INTERVAL);
*/
                }
            }

        });
        $('#id_PlaySpeedSlider').slider({ disabled: false });
    });

    $(function() {
        $("#button1").click(function() {    //Open
            VideoPlayModeFlag = VIDEO_STATUS_PLAY;
            var StrStartTime = document.all.ViewStartTime.value;
            var StrEndTime = document.all.ViewEndTime.value;

            var StartTime, EndTime;
            var StrStartTimePre, StrEndTimePre;
            var StrStartTimeTail, StrEndTimeTail;

            StartTime = StrStartTime.split(' ');
            StrStartTimePre = StartTime[0].split('.');
            StrStartTimeTail = StartTime[1].split(':');
            EndTime = StrEndTime.split(' ');
            StrEndTimePre = EndTime[0].split('.');
            StrEndTimeTail = EndTime[1].split(':');
            
            var StartTimeValue = StrStartTimePre[0] + "-" + StrStartTimePre[1] + "-" + StrStartTimePre[2] + "-" + StrStartTimeTail[0] + "-" + StrStartTimeTail[1] + "-" + StrStartTimeTail[2];
            var EndTimeValue = StrEndTimePre[0] + "-" + StrEndTimePre[1] + "-" + StrEndTimePre[2] + "-" + StrEndTimeTail[0] + "-" + StrEndTimeTail[1] + "-" + StrEndTimeTail[2];

            if (document.location.protocol == 'https:')
            {
                wsUri = "wss://" + IP + ":" + PORT + "/ws/FlexWatch-WebSocket?ServerId=0&AppKey=0x00000029&PortId=<% FwGetParmValue("PortId"); %>&SearchTime=" + StartTimeValue + "&PauseTime=" + EndTimeValue + "&SearchMode=1&FwCgiVer=0x0001";
            }
            else
            {
                wsUri = "ws://" + IP + ":" + PORT + "/ws/FlexWatch-WebSocket?ServerId=0&AppKey=0x00000029&PortId=<% FwGetParmValue("PortId"); %>&SearchTime=" + StartTimeValue + "&PauseTime=" + EndTimeValue + "&SearchMode=1&FwCgiVer=0x0001";
            }

            playwebsocket = new WebSocket(wsUri,["nipp"]);
            playwebsocket.onclose = function(evt) { onClose(evt) };
            playwebsocket.onmessage = function(evt) { onMessage(evt) };
            playwebsocket.onerror = function(evt) { onError(evt) };

            ClientEventSource = new EventSourceWrapper(client_eventSource);
            ClientEventSource.on('Flush', Flush.bind(this));

            setTimeout(function() {
                FlushHandler = setInterval(()=>{
                    client_eventSource.dispatchEvent('Flush');
                }, INTERVAL);
            }, 50);

            $('#id_PlaySpeedSlider').slider({ disabled: true });
            $("#button1").attr("disabled", true);
            $("#button2").attr("disabled", true);
            $("#button3").attr("disabled", true);
            $("#button4").attr("disabled", true);
            $("#button5").attr("disabled", true);
            $("#button6").attr("disabled", false);
            $("#button7").attr("disabled", false);
            $("#button8").attr("disabled", true);
        });

        $("#button2").click(function() {    //Play
            VideoPlayModeFlag = VIDEO_STATUS_PLAY;
            FlushHandler = setInterval(()=>{
                client_eventSource.dispatchEvent('Flush');
            }, INTERVAL);

            $("#button1").attr("disabled", true);
            $("#button2").attr("disabled", true);
            $("#button3").attr("disabled", true);
            $("#button4").attr("disabled", true);
            $("#button5").attr("disabled", true);
            $("#button6").attr("disabled", false);
            $("#button7").attr("disabled", false);
            $("#button8").attr("disabled", true);
        });

        $("#button3").click(function() {    //Back Play
        });

        $("#button4").click(function() {    //Next Move
            VideoPlayModeFlag = VIDEO_STATUS_STEP_NEXT;

            setTimeout(function() {
                clearInterval(FlushHandler);
            }, INTERVAL * 2);
            Converter.pause();

            if( RawImageQueue.length < 200 )
            {
                FlushHandler = setInterval(()=>{
                client_eventSource.dispatchEvent('Flush');
                }, INTERVAL);
            }
        });

        $("#button5").click(function() {    //Prev Move
            VideoStepPrev = 1;
        });

        $("#button6").click(function() {    //Pause
            VideoPlayModeFlag = VIDEO_STATUS_PAUSE;
            Converter.pause();
            setTimeout(function() {
                clearInterval(FlushHandler);
            }, INTERVAL * 2);
            
            $("#button1").attr("disabled", true);
            $("#button2").attr("disabled", false);
            $("#button3").attr("disabled", false);
            $("#button4").attr("disabled", false);
            $("#button5").attr("disabled", false);
            $("#button6").attr("disabled", true);
            $("#button7").attr("disabled", false);
            $("#button8").attr("disabled", true);
        });

        $("#button7").click(function() {    //Stop
            VideoPlayModeFlag = VIDEO_STATUS_STOP;
            Converter.pause();
            Converter.reset();
            setTimeout(function() {
                clearInterval(FlushHandler);
            }, INTERVAL * 2);

            playwebsocket.close();
            WebsockStatus = 0;

            WebsockQueues[0] = [];
            WebsockQueues[1] = [];
            RawImageQueue = [];
            RawImage = [];
            FirstWebsockFlag = 1;
            IframeFlag = false;
            jes_data = null;
            arrayBufferView = null;

            $('#id_PlaySpeedSlider').slider({ disabled: false });
            $("#button1").attr("disabled", false);
            $("#button2").attr("disabled", true);
            $("#button3").attr("disabled", true);
            $("#button4").attr("disabled", true);
            $("#button5").attr("disabled", true);
            $("#button6").attr("disabled", true);
            $("#button7").attr("disabled", true);
            $("#button8").attr("disabled", false);
        });

        $("#button8").click(function() {    //Record
            VideoPlayModeFlag = VIDEO_STATUS_PLAY;
            var StrStartTime = document.all.ViewStartTime.value;
            var StrEndTime = document.all.ViewEndTime.value;

            var StartTime, EndTime;
            var StrStartTimePre, StrEndTimePre;
            var StrStartTimeTail, StrEndTimeTail;

            StartTime = StrStartTime.split(' ');
            StrStartTimePre = StartTime[0].split('.');
            StrStartTimeTail = StartTime[1].split(':');
            EndTime = StrEndTime.split(' ');
            StrEndTimePre = EndTime[0].split('.');
            StrEndTimeTail = EndTime[1].split(':');
            
            var StartTimeValue = StrStartTimePre[0] + "-" + StrStartTimePre[1] + "-" + StrStartTimePre[2] + "-" + StrStartTimeTail[0] + "-" + StrStartTimeTail[1] + "-" + StrStartTimeTail[2];
            var EndTimeValue = StrEndTimePre[0] + "-" + StrEndTimePre[1] + "-" + StrEndTimePre[2] + "-" + StrEndTimeTail[0] + "-" + StrEndTimeTail[1] + "-" + StrEndTimeTail[2];
            var DateStartTimeStamp = new Date(StrStartTimePre[0], ('00' + (Number(StrStartTimePre[1]) - 1)).slice(-2), ('00' + StrStartTimePre[2]).slice(-2), ('00' + StrStartTimeTail[0]).slice(-2), ('00' + StrStartTimeTail[1]).slice(-2), ('00' + StrStartTimeTail[2]).slice(-2));
            var DateEndTimeStamp = new Date(StrEndTimePre[0], ('00' + (Number(StrEndTimePre[1]) - 1)).slice(-2), ('00' + StrEndTimePre[2]).slice(-2), ('00' + StrEndTimeTail[0]).slice(-2), ('00' + StrEndTimeTail[1]).slice(-2), ('00' + StrEndTimeTail[2]).slice(-2));

            if( (DateEndTimeStamp - DateStartTimeStamp) <= 0)
            {
                alert("Wrong Time");
                return false;
            }
            else if( (DateEndTimeStamp - DateStartTimeStamp) > 300000)
            {
                alert("Save Limit is 5 Minute");
                return false;
            }

            RecordFrame = FPS *(DateEndTimeStamp - DateStartTimeStamp) / 1000;
            RecordFrameCount = 0;
            RecordName = StrStartTimePre[0] + "_" + StrStartTimePre[1] + "_" + StrStartTimePre[2] + "_" + StrStartTimeTail[0] + "_" + StrStartTimeTail[1] + ".webm";

            if (document.location.protocol == 'https:')
            {
                wsUri = "wss://" + IP + ":" + PORT + "/ws/FlexWatch-WebSocket?ServerId=0&AppKey=0x00000029&PortId=<% FwGetParmValue("PortId"); %>&SearchTime=" + StartTimeValue + "&PauseTime=" + EndTimeValue + "&SearchMode=1&FwCgiVer=0x0001";
            }
            else
            {
                wsUri = "ws://" + IP + ":" + PORT + "/ws/FlexWatch-WebSocket?ServerId=0&AppKey=0x00000029&PortId=<% FwGetParmValue("PortId"); %>&SearchTime=" + StartTimeValue + "&PauseTime=" + EndTimeValue + "&SearchMode=1&FwCgiVer=0x0001";
            }

            recordwebsocket = new WebSocket(wsUri,["nipp"]);
            recordwebsocket.onclose = function(evt) { onClose(evt) };
            recordwebsocket.onmessage = function(evt) { onRecordMessage(evt) };
            recordwebsocket.onerror = function(evt) { onError(evt) };

            ClientEventSource = new EventSourceWrapper(client_eventSource);
            ClientEventSource.on('FlushRecord', FlushRecord.bind(this));

            setTimeout(function() {
                FlushRecordHandler = setInterval(()=>{
                    client_eventSource.dispatchEvent('FlushRecord');
                }, INTERVAL);
            }, 50);

            $('#id_PlaySpeedSlider').slider({ disabled: true });
            $("#button1").attr("disabled", true);
            $("#button2").attr("disabled", true);
            $("#button3").attr("disabled", true);
            $("#button4").attr("disabled", true);
            $("#button5").attr("disabled", true);
            $("#button6").attr("disabled", true);
            $("#button7").attr("disabled", true);
            $("#button8").attr("disabled", true);
        });
    });
</script>
</html>
