<html>
<head>
    <% FwIncludeFile("/web/charset.txt"); %>
    <meta http-equiv="expires" content="0">
    <meta http-equiv="pragma" content="no-cache">
    <link rel="stylesheet" href="/style.css" type="text/css">
    <script language="javascript">
    <% NetDefIpFilter("Normal"); %>

    function GetData() {
        with(document.all) {
            if( FILTER_NORMAL_IPRANGES == "*" && FILTER_NORMAL_SERVICES == 1 ) {
                NormalIpFilteringType[0].checked = true;
                NormalIpFilteringType[1].checked = false;
                NormalIpFilteringType[2].checked = false;
            } else if( FILTER_NORMAL_SERVICES == 2 ) {
                NormalIpFilteringType[0].checked = false;
                NormalIpFilteringType[1].checked = false;
                NormalIpFilteringType[2].checked = true;

                GetNormalFilteringList();
            } else {
                NormalIpFilteringType[0].checked = false;
                NormalIpFilteringType[1].checked = true;
                NormalIpFilteringType[2].checked = false;

                GetNormalFilteringList();
            }

            ChgNormalService();
        }
    }

    function GetNormalFilteringList() {
        with(document.all) {
            if (FILTER_NORMAL_IPRANGES != "" && FILTER_NORMAL_IPRANGES != "*") {
                var filter_normal_s_ip = FILTER_NORMAL_IPRANGES.split(" ");
                var idx = 0;

                while (filter_normal_s_ip[idx] != null){
                    NormalFilteringList.options[idx] = new Option(filter_normal_s_ip[idx], idx);
                    idx++;
                }
            }
        }
    }

    function ChgNormalService() {
        with(document.all) {
            if ( NormalIpFilteringType[1].checked || NormalIpFilteringType[2].checked ) {
                StartIP.disabled = false;
                EndIP.disabled = false;
                NormalFilteringList.disabled = false;
                tonormaladd.disabled = false;
                tonormalup.disabled = false;
                tonormaldown.disabled = false;
                tonormaldelete.disabled = false;

                GetNormalFilteringList();
            } else {
                StartIP.disabled = true;
                EndIP.disabled = true;
                NormalFilteringList.disabled = true;
                tonormaladd.disabled = true;
                tonormalup.disabled = true;
                tonormaldown.disabled = true;
                tonormaldelete.disabled = true;

                for (var len = 0; len < NormalFilteringList.options.length; len++) {
                    NormalFilteringList.options[len] = null;
                }
                NormalFilteringList.options.length = 0;
            }
        }
    }

    function SwapIndex(selectBoxListObj, idx, jdx) {
        var idx_new_option = selectBoxListObj.options[idx];
        var jdx_new_option = selectBoxListObj.options[jdx];

        selectBoxListObj.options[idx] = new Option();
        selectBoxListObj.options[jdx] = new Option();

        selectBoxListObj.options[idx] = jdx_new_option;
        selectBoxListObj.options[jdx] = idx_new_option;
    }

    function AddNormalIP() {
        with(document.all) {
            if (NormalFilteringList.length > 19) {
                alert("Can not register whitelists more than 20.");
                return false;
            }

            var s_ip = StartIP.value.split(".");
            for (var i = 0; i < 4; i++) {
                if (isNaN(Number(s_ip[i], 10))) {
                    alert("\'" + s_ip[i] + "\' is not a number or incorrect format !");
                    StartIP.focus();
                    return false;
                } else if (Number(s_ip[i], 10) < 0 || Number(s_ip[i], 10) > 255) {
                    alert("Address should be 0 ~ 255 ");
                    StartIP.focus();
                    return false;
                }
            }

            if (EndIP.value != "") {
                var e_ip = EndIP.value.split(".");
                for (var i = 0; i < 4; i++) {
                    if (isNaN(Number(e_ip[i], 10))) {
                        alert("\'" + e_ip[i] + "\' is not a number or incorrect format !");
                        EndIP.focus();
                        return false;
                    } else if (Number(e_ip[i], 10) < 0 || Number(e_ip[i], 10) > 255) {
                        alert("Address should be 0 ~ 255 ");
                        EndIP.focus();
                        return false;
                    }
                }
            }

            var idx = NormalFilteringList.length;
            var IpListVal;
            if (EndIP.value != "") {
                var IP = StartIP.value + "-" + EndIP.value;
                IpListVal = StartIP.value + "-" + EndIP.value;
            } else {
                var IP = StartIP.value + "-" + StartIP.value;
                IpListVal = StartIP.value + "-" + StartIP.value;
            }
            NormalFilteringList.options[idx] = new Option(IP, idx);
        }
    }

    function MoveUpNormalIP() {
        with(document.all) {
            for (var idx = 1; idx < NormalFilteringList.options.length; idx++) {
                if (NormalFilteringList.options[idx].selected) {
                    if (NormalFilteringList.options[idx - 1].selected) {
                        continue;
                    }
                    else {
                        this.SwapIndex(NormalFilteringList, idx, idx - 1);
                    }
                }
            }
        }
    }

    function MoveDownNormalIP() {
        with(document.all) {
            for (var idx = NormalFilteringList.options.length - 2; idx >= 0; idx--) {
                if (NormalFilteringList.options[idx].selected) {
                    if (NormalFilteringList.options[idx + 1].selected) {
                        continue;
                    }
                    else {
                        this.SwapIndex(NormalFilteringList, idx, idx + 1);
                    }
                }
            }
        }
    }

    function DeleteNormalIP() {
        with(document.all) {
            var idx = NormalFilteringList.selectedIndex;
            if (idx > -1) {
                NormalFilteringList.options[idx] = null;
            }

            for (var i = 0; i < NormalFilteringList.length; i++) {
                var temp = NormalFilteringList.options[i].text;
                var IP = temp;
                NormalFilteringList.options[i] = new Option(IP, i);
            }
        }
    }

    function VerifyIp(inpobj) {
        var address = inpobj.value.split(".");
        for (var i = 0; i < 4; i++) {
            if (isNaN(Number(address[i], 10))) {
                alert("\'" + address[i] + "\' is not a number or incorrect format !");
                inpobj.focus();
                break;
            }
            if (Number(address[i], 10) < 0 || Number(address[i], 10) > 255) {
                alert("Address should be 0 ~ 255 ");
                inpobj.focus();
            }
        }
    }

    function VerifyIp2(inpobj) {
        if (inpobj.value != "") {
            var address = inpobj.value.split(".");
            for (var i = 0; i < 4; i++) {
                if (isNaN(Number(address[i], 10))) {
                    alert("\'" + address[i] + "\' is not a number or incorrect format !");
                    inpobj.focus();
                    break;
                }
                if (Number(address[i], 10) < 0 || Number(address[i], 10) > 255) {
                    alert("Address should be 0 ~ 255 ");
                    inpobj.focus();
                }
            }
        }
    }

    function SetData() {
        with(document.all) {
            sure = confirm("Please check again, your PC IP will be NOT filtered.\nDo you want to proceed?");
            if (sure) {
                confirmsure = confirm("Really want to apply the changed settings??");

                if(!confirmsure) {
                    return false;
                }

                tonormaladd.disabled = true;
                tonormalup.disabled = true;
                tonormaldown.disabled = true;
                tonormaldelete.disabled = true;

                toapply.disabled = true;

                if (NormalIpFilteringType[0].checked) {
                    NormalIpFilterRanges.value = "*";
                } else if (NormalIpFilteringType[1].checked || NormalIpFilteringType[2].checked) {
                    for (var idx = 0; idx < NormalFilteringList.length; idx++) {
                        var IpRangeText = NormalFilteringList.options[idx].text;

                        if ( idx >= 0 && idx < (NormalFilteringList.length - 1) ) {
                            NormalIpFilterRanges.value += IpRangeText;
                            NormalIpFilterRanges.value += " ";
                        } else if ( idx == (NormalFilteringList.length - 1) ) {
                            NormalIpFilterRanges.value += IpRangeText;
                        }
                    }

                    if (NormalIpFilterRanges.value == "")
                        NormalIpFilterRanges.value = "none"; 
                }
            } else {
                return false;
            }
        }
    }
    </script>
</head>

<body class=body_Normal onload="GetData();" topmargin=30>
    <form name='filtering' method=Post action="/cgi-bin/admin/net_set_normal_remote_ipfilter.cgi" onSubmit="return SetData();">
        <table border=0 cellpadding=0 cellspacing=0 align=center>
            <tr>
                <td height=60 align=center>
                    <font class=text_Title>IP Filtering</font>
                </td>
            </tr>
        </table>
        <table class=tbl_Normal cellspacing=0 align=center width=550>
            <tr height=30>
                <td class=td_HighLeft colspan="2">&nbsp;Normal</td>
            </tr>
            <tr>
                <td width=118 class=td_NormalLeft>&nbsp;Service</td>
                <td class=td_NormalRight>&nbsp;
                    <input type=radio name=NormalIpFilteringType value=0 onclick="ChgNormalService();"> All Accept&nbsp;
                    <input type=radio name=NormalIpFilteringType value=1 onclick="ChgNormalService();"> Selected IP Accept&nbsp;
                    <input type=radio name=NormalIpFilteringType value=2 onclick="ChgNormalService();"> Selected IP Deny
                </td>
            </tr>
            <tr height=30>
                <td width=130 class=td_NormalLeft>&nbsp;IP Range</td>
                <td class=td_NormalRight>&nbsp;
                    <input type=text name=StartIP size=18 maxlength=15 class=obj_Normal onChange="VerifyIp(StartIP);"> ~
                    <input type=text name=EndIP size=18 maxlength=15 class=obj_Normal onChange="VerifyIp2(EndIP);">&nbsp;
                    <input type=button class=obj_Button name=tonormaladd value=" Add " style="width:65px;" onClick="AddNormalIP();">
                </td>
            </tr>         
            <tr height=30>
                <td class=td_NormalLeft>&nbsp;IP List</td>
                <td align="right">
                    <input type=button class=obj_Button name=tonormalup value=" Up " style="width:65px;" onClick="MoveUpNormalIP();">
                    <input type=button class=obj_Button name=tonormaldown value=" Down " style="width:65px;" onClick="MoveDownNormalIP();">
                    <input type=button class=obj_Button name=tonormaldelete value=" Delete " style="width:65px;" onClick="DeleteNormalIP();">&nbsp;
                </td>
            </tr>
            <tr>
                <td colspan="2">
                    <select id=NormalFilteringList size=12 style="width:550px; height:100px;">
                    </select>
                </td>
            </tr>
        </table>

        <table align=center>
            <tr>
                <td height=50 align="center">
                    <input type=submit class=obj_Button name=toapply value=" Apply ">
                </td>
            </tr>
        </table>

        <table align=center>
            <tr>
                <td valign=top>
                    <font class=text_Notice><em>Notice</em></font> : 
                </td>
                <td>When you select Deny policy, your PC IP should NOT be in the IP List.
                    <br> When you select Accept policy, your PC IP should Be in the IP List.
                </td>
            </tr>
        </table>
        <input type=hidden name="NormalIpFilterRanges">
        <input type=hidden name="RetPage" value="/admin/ret_ok.asp">
        <input type=hidden name="SaveCfg" value="YES">
        <input type=hidden name="FwRmChg" value="YES">
        <input type=hidden name="CgiVer" value="0x0001">
        <input type=hidden name="ChkNetChg" value="YES">
    </form>
</body>
</html>
