<html>
<head>
    <% FwIncludeFile("/web/charset.txt"); %>
	<title>Help of FTP(Buffered)</title>
	<meta http-equiv="pragma" content="no-cache">
	<link rel="stylesheet" href="/style.css" type="text/css">
	<script language="Javascript">
      onBlur=self.focus();
    </script>
</head>

<body class=body_Update leftmargin=0 topmargin=0>
<table border=0 cellspacing=0 cellpadding=0 align=center width=500>
  <tr> 
    <td height=25 align=right class=bar_Normal><font class=text_Bar>Help 
      of FTP(Buffered)</font>&nbsp;</td>
  </tr>
  <tr> 
    <td height=50 align=center> <table cellpadding=0 cellspacing=0 border=0 width=480>
        <tr> 
          <td height="25" align="center"><b>Trouble Shooting Guide for FTP service</b></td>
        </tr>
        <tr> 
          <td height="140">This guide provides useful information to solve most difficulties you may have with the FTP service.
            <p>You need to have a good understanding of &#8220;<font color="#003399">Pre/post 
              alarm buffering</font>&#8221;, &#8220;<font color="#003399">Condition</font>&#8221;, 
              &#8220;<font color="#003399">FTP directory &amp; Name option</font>&#8221; 
              and &#8220;<font color="#003399">Sequence &amp; Overwrite option</font>&#8221; 
              from the User Manual.</p></td>
        </tr>
        <tr> 
          <td><li>You must create 'Base directory' in your FTP server before setting 
              up FTP<br>
              service configuration.</li>
            <br> <br> 
              <li>After creating the 'Base directory' in your FTP server, 
                  verify you have permissions to read and write image files in the directory. 
                  To do this, upload and download any files onto 'Base directory'.</li><br><br>
              <li>You need to check the 
              available storage capacity in your FTP server.</li>
            <br> <br> <li>Depending on your network and FTP service, there are some differences in 
                FTP service configuration. Some settings are subject to change by the network or FTP service.</li>
            <br> <br> <li>Up to 3 different conditions can be applied to each 
              camera. Each condition must be set logically.</li>
            <br> <br> <li>'Base directory' and 'Base file' names must be registered
                on the FTP service configuration menu while 'Directory and File options' 
                are optional functions.</li>
            <br> <br> <li>If your FTP server is placed within a Firewall-network 
              environment, select 'Passive' mode in the FTP configuration menu and configure the FTP server
                as 'Active' mode. Contact your network administrator for more details.</li>
            <br> <br> <table width="480" border="0" cellspacing="0" cellpadding="0">
              <tr> 
                <td height="90" colspan="2"><li>When you input &#8217;Base Directory 
                    Name&#8217; on the FTP service configuration menu;</li>
                  <br>
                  a) If you create 'Base directory' under <strong><font color="#003399">'home</font></strong>'
                  directory of your FTP server, <br>
                  you can simply input the name of 'Base directory' only in the 
                  blank as below.</td>
              </tr>
              <tr> 
                <td width="100%">&nbsp;&nbsp; Ex) &quot;/home/user1/ftpdata&quot; 
                  =&gt;</td>
                <td bgcolor="#FFFFFF"><div align="right"><img src="ftp_a.gif" width="260" height="20"></div></td>
              </tr>
              <tr> 
                <td height="70" colspan="2"> b) If you create 'Base directory' 
                  at any place under <strong><font color="#003399">'/ (root)'</font></strong> 
                  of your FTP server, you you must fully input all the absolute paths from
                  '/ (root)' to the name of 'Base directory'.</td>
              </tr>
              <tr> 
                <td> &nbsp;&nbsp; Ex) &quot;/ftpdata&quot; =&gt;</td>
                <td bgcolor="#FFFFFF"><div align="right"><img src="ftp_b.gif" width="260" height="21"></div></td>
              </tr>
              <tr> 
                <td> &nbsp;&nbsp; Or &quot; /.&#8230;/&#8230;./..../ftpdata&quot; 
                  =&gt;</td>
                <td bgcolor="#FFFFFF"><div align="right"><img src="ftp_c.gif" width="260" height="21"></div></td>
              </tr>
            </table></td>
        </tr>
        <tr> 
          <td><table width=480>
              <tr> 
                <td height="85"><li> Directory option is to provide more sub directory and file 
                  name so that you can create classified directory to manage ftped 
                  image more effectively. Note that you can select only one Directory 
                  name from the Directory name option. But you can select multiple file name options.</li></td>
              </tr>
              <tr> 
                <td>&nbsp;&nbsp;&nbsp;<img src="op.gif"></td>
              </tr>
              <tr> 
                <td height="160"> <ul>
                    <li>Weekday : "SUN","MON","TUE","WED","THU","FRI","SAT"</li>
                    <li>Month : "Jan","Feb","Mar",....,"Dec"</li>
                    <li>Day : "1st","2nd","3rd",......,"31<sup>st</sup>"</li>
                    <li>Hour : "00","01","02",......,"23"</li>
                    <li>Minute : "00","01","02",......,"59"</li>
                    <li>Sec : "00","01","02",......,"59"</li>
                    <li>Sequence : "00000000"~"99999999"</li>
                    <li>Camera Number : "CAM1","CAM2",...,"CAM6"</li>
                  </ul></td>
              </tr>
            </table></td>
        </tr>
        <tr>
          <td height="85"><font color="#FF0000"><strong>WARNING!!! </strong><br>
            To apply the new FTP configurations, click the <em><strong>"Apply"</strong></em> button 
            under the status bar, click <em><strong>"Save Configuration"</strong></em> and then click 
            <em><strong>"Reboot"</strong></em>.<br>
            <br>
            <strong>WARNING!!! </strong><br>
            All the following configuration steps must be set in order. If any 
            steps are missed or in the wrong order, the system will not work properly.</font></td>
        </tr>
      </table></td>
  </tr>
  <tr> 
    <td align=center>&nbsp; </td>
  </tr>
  <tr> 
    <td align=center height=40><form>
        <input type=button value=" Close " onclick="javascript:window.close();" class=obj_Button>
      </form></td>
  </tr>
</table>
</body>
</html>
